var script_version_info = "Goma-An version 3.8.20.20180216";
var script_author_info  = "by Takanori Sato, 2007-2018";

var data_file = "gomaan.txt";
var data_dir = "";
var use_jquery_colorbox = false;  // jQuery Colorbox を使用する場合は，htmlファイルで組み込みが必要

var center_lat = 36.0;
var center_lng = 136.5;
var map_zoom = 4;
var map_type_preset = "ROADMAP";
var zoom_max = 19;
var zoom_min = 0;
var map_type_options_preset = [
	"ROADMAP",
	"HYBRID",
	"GSIstd"
];
var info_window_max_width = 400;
var use_search_box = false;
var use_link_url = false;
var sideBarVisibility = true;
var iconSideBar_right_close = "arrow_lc.png"
var iconSideBar_right_open = "arrow_lo.png"
var iconSideBar_bottom_close = "arrow_pc.png"
var iconSideBar_bottom_open = "arrow_po.png"
var opening_message = "";
var opening_message_lat = ""; var opening_message_lng = "";
var description = "<p style=\"margin:0.5em 0em; font-size:100%; line-height:125%; text-align:justify; text-justify:inter-ideograph;\">"
	+ "地図中に表示されたマーカー等をクリックすると、その場所についての情報を見ることができます。"
	+ "</p>";
var visibility_marker = true;
var cache_refresh = false;
var description4system0 = "";
var description4system = "";

var default_url = "";
var map = null;
var map_type_id = null;
var useMapNote = {};
var useMapLegend = {};
var infowindow = null;
var markers = [];
var layerNum = 0;
var layerName = [];
var layerVisibility = [];
var layerIncludeGpx = [];
var groundoverlays = [];
var groundoverlays_opacity = [];
var groundoverlays_clickable = [];
var kmlLayers = [];
var kmlLayerNum = 0;
var kmlLayerName = [];
var kmlLayerVisibility = [];
var jsonLayers = [];
var jsonLayerNum = 0;
var jsonLayerName = [];
var jsonLayerVisibility = [];
var customControlDiv_MapCredit = null;
var layout_type = 0;
var url_arg_data = "";
var url_arg_file = "";

// Google Maps API (Geocoder機能) 専用
var geocoder = null;
var geocode_results = null;
var geocode_index = 0;
var infowindow_search = null;

// 外部ファイルによる地図タイル定義の拡張の有無を判定
if (typeof use_ext_tile === "undefined") {
	var use_ext_tile = false;
}

function setColorbox() {
	if (use_jquery_colorbox == true) {
		$("a.lightbox").colorbox({opacity:0.7, maxWidth:'100%', maxHeight:'100%'}); // jQuery Colorbox のセット
	}
}

function mapTypeIdFromNameWord(word) {
	var id = null;
	switch ( word.toLowerCase() ) {
		case "googleroadmap":
		case "google roadmap":
		case "google road map":
		case "roadmap":
		case "road map":
		case "m":
			id = google.maps.MapTypeId.ROADMAP;
			break;
		case "googleterrain":
		case "google terrain":
		case "terrain":
		case "p":
			id = google.maps.MapTypeId.TERRAIN;
			break;
		case "googlesatellite":
		case "google satellite":
		case "satellite":
		case "k":
			id = google.maps.MapTypeId.SATELLITE;
			break;
		case "googlehybrid":
		case "google hybrid":
		case "hybrid":
		case "h":
			id = google.maps.MapTypeId.HYBRID;
			break;
		case "gsistd":
		case "std":
		case "gsi":
		case "gsimap":
			id = "GSIstd";
			break;
		case "gsipale":
		case "pale":
			id = "GSIpale";
			break;
		case "gsienglish":
		case "english":
			id = "GSIenglish";
			break;
		case "gsirelief":
		case "relief":
			id = "GSIrelief";
			break;
		case "gsilcm25k":
		case "gsilcm":
		case "lcm":
		case "land condition":
		case "landcondition":
			id = "GSIlcm25k";
			break;
		case "gsilum4bl":
		case "gsilum":
		case "lum":
		case "land use":
		case "landuse":
			id = "GSIlum4bl";
			break;
		case "gsiblank":
		case "blank":
			id = "GSIblank";
			break;
		case "gsiphoto":
		case "gsiseamlessphoto":
		case "photo":
		case "seamlessphoto":
			id = "GSIphoto";
			break;
		case "gsiort":
		case "ort":
//			id = "GSIort";
			id = "GSIort2";
			break;
		case "gsiort2": // オルソ画像のみ（小縮尺はオルソ整備範囲）
			id = "GSIort2";
			break;
		case "gsiair":
		case "air":
		case "airphoto":
			id = "GSIair";
			break;
		case "gsigazo1":
		case "gazo1":
		case "nlii1":
			id = "GSIgazo1";
			break;
		case "gsigazo2":
		case "gazo2":
		case "nlii2":
			id = "GSIgazo2";
			break;
		case "gsigazo3":
		case "gazo3":
		case "nlii3":
			id = "GSIgazo3";
			break;
		case "gsigazo4":
		case "gazo4":
		case "nlii4":
			id = "GSIgazo4";
			break;
		case "gsiortold10":
		case "ort_old10":
		case "ortold10":
			id = "GSIortOld10";
			break;
		case "gsiortusa10":
		case "ort_usa10":
		case "ortusa10":
			id = "GSIortUSA10";
			break;
		case "kiban25000":
		case "kbn25000anf":
			id = "Kiban25000";
			break;
		case "kiban2500":
		case "kbn2500fn":
			id = "Kiban2500";
			break;
		case "kiban25000a":
		case "kiban":
			id = "Kiban25000a";
			break;
		case "kiban25000c":
		case "kbn25000cnb":
		case "contour":
			id = "Kiban25000c";
			break;
		case "findshawmskanto":
		case "findshawms":
		case "hawms":
		case "hawmskanto":
		case "jinsoku":
			id = "FindsHawmsKanto";
			break;
		case "kjmap2man":
		case "meiji2man":
		case "meiji":
			id = "Kjmap2man";
			break;
		case "kjmap25k1920":
		case "25k1920":
			id = "Kjmap25k1920";
			break;
		case "kjmap25k1930":
		case "25k1930":
			id = "Kjmap25k1930";
			break;
		case "kjmap25k1950":
		case "25k1950":
			id = "Kjmap25k1950";
			break;
		case "kjmap25k1970":
		case "25k1970":
			id = "Kjmap25k1970";
			break;
		case "kjmap50k1910":
		case "50k1910":
			id = "Kjmap50k1910";
			break;
		case "kjmap50k1940":
		case "50k1940":
			id = "Kjmap50k1940";
			break;
		case "gsitoho1":
		case "toho1":
		case "tohoku1":
			id = "GSItoho1";
			break;
		case "gsitoho2":
		case "toho2":
		case "tohoku2":
			id = "GSItoho2";
			break;
		case "coordinate":
		case "coord":
		case "xyz":
			id = "Coordinate";
			break;
		case "coordinatesw":
		case "coordsw":
		case "xyz2":
			id = "CoordinateSw";
			break;
		case "white":
			id = "White";
			break;
		default:
			if (use_ext_tile == true) {
				id = extMapTypeIdFromNameWord(word);
			}
			break;
	}
	return id;
}

function setMapCreditControl() {
	customControlDiv_MapCredit = document.createElement('div');
	customControlDiv_MapCredit.innerHTML = '';
	customControlDiv_MapCredit.id = 'DivForMapCredit';
	customControlDiv_MapCredit.style.fontSize = '10px';
	customControlDiv_MapCredit.style.lineHeight = '14px';
	customControlDiv_MapCredit.style.color = '#444444';
	customControlDiv_MapCredit.style.backgroundColor = 'rgba(245,245,245,0.7)';
	customControlDiv_MapCredit.style.padding = '0px 5px';
	map.controls[google.maps.ControlPosition.BOTTOM_RIGHT].push(customControlDiv_MapCredit);
}

function indicateMapCredit() {
	var map_credit = "";
	var htmlGSI = "<a href=\"http://maps.gsi.go.jp/development/ichiran.html\" target=\"_blank\" style=\"color:inherit;\">国土地理院</a>";
	var htmlGSIe = "<a href=\"http://maps.gsi.go.jp/development/ichiran.html\" target=\"_blank\" style=\"color:inherit;\">Geospatial Information Authority of Japan</a>";
	var htmlFinds = "<a href=\"http://www.finds.jp/tmc/\" target=\"_blank\" style=\"color:inherit;\">農研機構</a>";
	var htmlKjmap = "<a href=\"http://ktgis.net/kjmapw/\" target=\"_blank\" style=\"color:inherit;\">今昔マップ on the web</a>";
	switch ( map.getMapTypeId() ) {
		case "GSIstd":
		case "GSIpale":
		case "GSIrelief":
		case "GSIlcm25k":
		case "GSIlum4bl":
		case "GSIblank":
			map_credit = "地図データ &copy; " + htmlGSI;
			break;
		case "GSIenglish":
			map_credit = "Map data &copy; " + htmlGSIe;
			break;
		case "GSIphoto":
		case "GSIort":
			map_credit = "画像 &copy; " + htmlGSI;
			break;
		case "GSIort2":
			if (map.getZoom() < 13) {
				map_credit = "地図データ &copy; " + htmlGSI;
			} else {
				map_credit = "画像 &copy; " + htmlGSI;
			}
			break;
		case "GSIair":
		case "GSIgazo1":
		case "GSIgazo2":
		case "GSIgazo3":
		case "GSIgazo4":
		case "GSIortOld10":
		case "GSIortUSA10":
			if (map.getZoom() < 10) {
				map_credit = "地図データ &copy; " + htmlGSI;
			} else {
				map_credit = "画像 &copy; " + htmlGSI;
			}
			break;
		case "Kiban25000":
		case "Kiban2500":
		case "Kiban25000a":
		case "Kiban25000c":
			map_credit = "地図データ　" + htmlFinds;
			break;
		case "FindsHawmsKanto":
			map_credit = "地図データ　" + htmlFinds;
			break;
		case "Kjmap2man":
			if (map.getZoom() < 11) {
				map_credit = "地図データ　" + htmlKjmap + ", " + htmlFinds;
			} else if (map.getCenter().lng() < 134.2 ) {
				map_credit = "地図データ　" + htmlFinds;
			} else {
				map_credit = "地図データ　" + htmlKjmap;
			}
			break;
		case "Kjmap25k1920":
		case "Kjmap25k1930":
		case "Kjmap25k1950":
		case "Kjmap25k1970":
		case "Kjmap50k1910":
		case "Kjmap50k1940":
			map_credit = "地図データ　" + htmlKjmap;
			break;
		case "GSItoho1":
		case "GSItoho2":
			map_credit = "画像 &copy; " + htmlGSI;
			break;
		case "Coordinate":
		case "CoordinateSw":
			map_credit = "地図データ &copy; " + htmlGSI;
			break;
		case google.maps.MapTypeId.ROADMAP:
		case google.maps.MapTypeId.TERRAIN:
		case google.maps.MapTypeId.SATELLITE:
		case google.maps.MapTypeId.HYBRID:
			map_credit = "";
			break;
		default:
			if (use_ext_tile == true) {
				map_credit = extMapCredit( map.getMapTypeId() );
			}
			break;
	}
	customControlDiv_MapCredit.innerHTML = map_credit;
}

function mapSourceNote(argMapTypeId, argMapTypeIdsArray) {
	var grossMapTypeIdsArray = [];
	if (argMapTypeId != null) {
		grossMapTypeIdsArray = [argMapTypeId];
	}
	if (argMapTypeIdsArray instanceof Array){
		for (var i = 0; i < argMapTypeIdsArray.length; i++) {
			grossMapTypeIdsArray.push(argMapTypeIdsArray[i]);
		}
	}
	useMapNote['GSI'] = false;
	useMapNote['GSI5M'] = false;
	useMapNote['GSI5M_j'] = false;
	useMapNote['GSI5M_e'] = false;
	useMapNote['GSI_VMAP0'] = false;
	useMapNote['GSIrelief'] = false;
	useMapNote['GSIsat'] = false;
	useMapNote['GSIphotoScale'] = false;
	useMapNote['GSIphotoYear'] = false;
	useMapNote['FindsKiban'] = false;
	useMapNote['FindsChimei'] = false;
	useMapNote['FindsHawmsKanto'] = false;
	useMapNote['FindsHawmsFkym'] = false;
	useMapNote['Kjmap'] = false;
	useMapLegend['GSIstd'] = false;
	useMapLegend['GSIpale'] = false;
	useMapLegend['GSIenglish'] = false;
	useMapLegend['GSIlcm25k'] = false;
	useMapLegend['GSIlum4bl'] = false;
	if (use_ext_tile == true) {
		extMapSourceNoteProcess1();
	}
	for (var i = 0; i < grossMapTypeIdsArray.length; i++) {
		switch ( grossMapTypeIdsArray[i] ) {
			case "GSIstd":
				useMapNote['GSI'] = true;
				useMapNote['GSI5M'] = true; useMapNote['GSI5M_j'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapLegend['GSIstd'] = true;
				break;
			case "GSIpale":
				useMapNote['GSI'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapLegend['GSIpale'] = true;
				break;
			case "GSIenglish":
				useMapNote['GSI'] = true;
				useMapNote['GSI5M'] = true; useMapNote['GSI5M_e'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapLegend['GSIenglish'] = true;
				break;
			case "GSIrelief":
				useMapNote['GSI'] = true; useMapNote['GSIrelief'] = true;
				break;
			case "GSIlcm25k":
				useMapNote['GSI'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapLegend['GSIlcm25k'] = true;
				break;
			case "GSIlum4bl":
				useMapNote['GSI'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapLegend['GSIlum4bl'] = true;
				break;
			case "GSIblank":
				useMapNote['GSI'] = true; useMapNote['GSI_VMAP0'] = true;
				break;
			case "GSIphoto":
			case "GSIort":
				useMapNote['GSI'] = true; useMapNote['GSIsat'] = true;
				break;
			case "GSIort2":
			case "GSIair":
				useMapNote['GSI'] = true;
				useMapNote['GSI5M'] = true; useMapNote['GSI5M_j'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapNote['GSIphotoScale'] = true;
				break;
			case "GSIgazo1":
			case "GSIgazo2":
			case "GSIgazo3":
			case "GSIgazo4":
			case "GSIortOld10":
			case "GSIortUSA10":
				useMapNote['GSI'] = true; 
				useMapNote['GSI5M'] = true; useMapNote['GSI5M_j'] = true; useMapNote['GSI_VMAP0'] = true;
				useMapNote['GSIphotoScale'] = true; useMapNote['GSIphotoYear'] = true;
				break;
			case "GSItoho1":
			case "GSItoho2":
				useMapNote['GSI'] = true;
				break;
			case "Kiban25000":
			case "Kiban2500":
			case "Kiban25000a":
			case "Kiban25000c":
				useMapNote['FindsKiban'] = true;
				break;
			case "FindsHawmsKanto":
				useMapNote['FindsHawmsKanto'] = true;
				break;
			case "Kjmap2man":
				useMapNote['Kjmap'] = true;
				useMapNote['FindsHawmsFkym'] = true;
				break;
			case "Kjmap25k1920":
			case "Kjmap25k1930":
			case "Kjmap25k1950":
			case "Kjmap25k1970":
			case "Kjmap50k1910":
			case "Kjmap50k1940":
				useMapNote['Kjmap'] = true;
				break;
			case "Coordinate":
			case "CoordinateSw":
				useMapNote['GSI'] = true;
				useMapNote['GSI5M'] = true; useMapNote['GSI5M_j'] = true; useMapNote['GSI_VMAP0'] = true;
				break;
			default:
				if (use_ext_tile == true) {
					extMapSourceNoteProcess2( grossMapTypeIdsArray[i] );
				}
				break;
		}
	}
	var mapNoteText = "";
	if ( (useMapLegend['GSIstd'] == true)||(useMapLegend['GSIpale'] == true)||(useMapLegend['GSIlcm25k'] == true)||(useMapLegend['GSIlum4bl'] == true) ) {
		mapNoteText += "凡例 ";
	}
	if (useMapLegend['GSIlcm25k'] == true) {
		mapNoteText += "　<a href=\"http://cyberjapandata.gsi.go.jp/legend/lcm25k_2012/lc_legend.pdf\" target=\"_blank\">土地条件図</a>";
	}
	if (useMapLegend['GSIlum4bl'] == true) {
		mapNoteText += "　<a href=\"http://cyberjapandata.gsi.go.jp/legend/takuchi_hanrei.png\" target=\"_blank\">土地利用図</a>";
	}
	if (useMapLegend['GSIstd'] == true) {
		mapNoteText += "　地理院地図（ズームレベル <a href=\"http://cyberjapandata.gsi.go.jp/legend/globalmaphyoko-legend.pdf\" target=\"_blank\">0-4</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/5000000-legend.pdf\" target=\"_blank\">5-8</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/std1000000_legend.pdf\" target=\"_blank\">9-11</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/std_200000_legend.pdf\" target=\"_blank\">12-14</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/std_25000_legend.pdf\" target=\"_blank\">15-17</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/std_2500_legend.pdf\" target=\"_blank\">18</a>）";
	}
	if (useMapLegend['GSIpale'] == true) {
		mapNoteText += "　地理院淡色地図（ズームレベル <a href=\"http://cyberjapandata.gsi.go.jp/legend/pale_5000000_legend.pdf\" target=\"_blank\">5-8</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/pale_1000000_legend.pdf\" target=\"_blank\">9-11</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/pale_200000_legend.pdf\" target=\"_blank\">12-14</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/pale_25000_legend.pdf\" target=\"_blank\">15-17</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/pale_2500_legend.pdf\" target=\"_blank\">18</a>）";
	}
	if ( (useMapLegend['GSIstd'] == true)||(useMapLegend['GSIpale'] == true)||(useMapLegend['GSIlcm25k'] == true)||(useMapLegend['GSIlum4bl'] == true) ) {
		mapNoteText += "<br />";
	}
	if (useMapLegend['GSIenglish'] == true) {
		mapNoteText += "Legend: English Map <a href=\"http://cyberjapandata.gsi.go.jp/legend/english_5000000_legend.pdf\" target=\"_blank\">zoom level 5-8</a>, <a href=\"http://cyberjapandata.gsi.go.jp/legend/hyoujyun1000000e_legend.pdf\" target=\"_blank\">zoom level 9-11</a><br />";
	}
	if ( (useMapLegend['GSIstd'] == true)||(useMapLegend['GSIpale'] == true)||(useMapLegend['GSIlcm25k'] == true)||(useMapLegend['GSIlum4bl'] == true)||(useMapLegend['GSIenglish'] == true) ) {
		mapNoteText += "<br />";
	}
	if (useMapNote['GSIphotoScale'] == true) {
		mapNoteText += "国土地理院の空中写真のうち一部のもの（過去の写真など）は一定の縮尺以上に拡大しないと表示されません。 また，画像の整備地域が限られているため，表示されない地域もあります。 空中写真の代わりに地図が色に染まって表示される場合はズームレベルを上げる（拡大する）と空中写真が表示されます。 色に染まっていない普通の地図が表示される場合はその地域の空中写真はありません。<br /><br />";
	}
	if ((useMapNote['GSIphotoYear'] == true) || (useMapNote['Kjmap'] == true)) {
		if (useMapNote['Kjmap'] == true) {
			mapNoteText += "地図切り替えメニューに地図の種類として表示されている数字（年）や年号は，地図が作成された大まかな時期を表しています。（最大で20年程度の期間内に作成された地図をつなぎ合わせています。）　正確な測量年や刊行年を示すものではありませんので，ご注意ください。<br />";
		}
		if (useMapNote['GSIphotoYear'] == true) {
			mapNoteText += "地図切り替えメニューに空中写真の種類として表示されている数字（年）は，空中写真が撮影された大まかな時期を表しています。（５年程度の期間内に撮影された空中写真をつなぎ合わせています。）　正確な撮影年を示すものではありませんので，ご注意ください。<br />";
		}
		mapNoteText += "<br />";
	}
	if (useMapNote['GSI'] == true) {
		mapNoteText += "このウェブサイトでは国土地理院の提供する<a href=\"http://maps.gsi.go.jp/development/ichiran.html\" target=\"_blank\">「地理院タイル」</a>を使用しています。 ご利用に当たっては<a href=\"http://www.gsi.go.jp/kikakuchousei/kikakuchousei40182.html\" target=\"_blank\">地理院コンテンツ利用規約</a>をご覧ください。 "; // +"<br />";
		mapNoteText += "<a href=\"http://maps.gsi.go.jp/development/ichiran.html\" target=\"_blank\">地図の種類</a>によっては基本測量成果に該当するものがあります。 基本測量成果に該当する地図を使用（複製等）する場合には<a href=\"http://www.gsi.go.jp/LAW/2930-index.html\" target=\"_blank\">国土地理院の地図の利用手続</a>をご覧ください。<br />";
	}
	if (useMapNote['GSI5M'] == true) {
		mapNoteText += "The bathymetric contours are derived from those contained within the GEBCO Digital Atlas, published by the BODC on behalf of IOC and IHO (2003) (<a href=\"http://www.gebco.net\" target=\"_blank\">http://www.gebco.net</a>).<br />";
	}
	if (useMapNote['GSI5M_j'] == true) {
		mapNoteText += "海上保安庁許可 第222510号 （水路業務法第25条に基づく類似刊行物）<br />";
	}
	if (useMapNote['GSI5M_e'] == true) {
		mapNoteText += "海上保安庁許可 第262520号 （水路業務法第25条に基づく類似刊行物）<br />";
	}
	if (useMapNote['GSI_VMAP0'] == true) {
		mapNoteText += "Shoreline data is derived from: United States. National Imagery and Mapping Agency. &quot;Vector Map Level 0 (VMAP0).&quot; Bethesda, MD: Denver, CO: The Agency; USGS Information Services, 1997.<br />";
	}
	if (useMapNote['GSIrelief'] == true) {
		mapNoteText += "段彩陰影図の海域部は海上保安庁海洋情報部の資料を使用して作成。<br />";
	}
	if (useMapNote['GSIsat'] == true) {
		mapNoteText += "データソース：Landsat8画像(GSI,TSIC,GEO Grid/AIST), Landsat8画像(courtesy of the U.S. Geological Survey),  海底地形(GEBCO)<br />";
		mapNoteText += "Images on this map obtained from site <a href=\"https://lpdaac.usgs.gov/data_access\" target=\"_blank\">https://lpdaac.usgs.gov/data_access</a> maintained by the NASA Land Processes Distributed Active Archive Center (LP DAAC), USGS/Earth Resources Observation and Science (EROS) Center, Sioux Falls, South Dakota.<br />";
	}
	if (useMapNote['Kjmap'] == true) {
		mapNoteText += "このウェブサイトでは埼玉大学教育学部の谷謙二氏による<a href=\"http://ktgis.net/kjmapw/index.html\" target=\"_blank\">時系列地形図閲覧サイト「今昔マップ on the web」</a>の地図画像を使用しています。 ご利用に当たっては同サイトの<a href=\"http://ktgis.net/kjmapw/note.html\" target=\"_blank\">使用上の注意</a>をご覧ください。<br />";
	}
	if ( (useMapNote['FindsKiban'] == true) || (useMapNote['FindsChimei'] == true) || (useMapNote['FindsHawmsKanto'] == true) || (useMapNote['FindsHawmsFkym'] == true) ) {
		mapNoteText += "このウェブサイトでは";
		var following = 0;
		if (useMapNote['FindsKiban'] == true) {
			mapNoteText += "「基盤地図情報 (国土地理院)」";
			following += 1;
		}
		if (useMapNote['FindsHawmsFkym'] == true) {
			if (following > 0) {
//				mapNoteText += ","; // カンマを入れる？
			}
			mapNoteText += "「２万分の１正式図 (国土地理院)」";
			following += 1;
		}
		if (useMapNote['FindsChimei'] == true) {
			if (following > 0) {
//				mapNoteText += ",";
			}
			mapNoteText += "「国土数値情報・位置参照情報 (国土交通省国土政策局)」";
			following += 1;
		}
		if (useMapNote['FindsHawmsKanto'] == true) {
			if (following > 0) {
//				mapNoteText += ",";
			}
			mapNoteText += "「歴史的農業環境閲覧システム (農業環境技術研究所)」";
			following += 1;
		}
		mapNoteText += "を使用した農研機構 Finds.jp による地図画像配信サービス（<a href=\"http://www.finds.jp/tmc/\" target=\"_blank\">タイル地図キャッシュサービス</a>）を使用しています。 ";
		mapNoteText += "同サービスの<a href=\"http://www.finds.jp/mapprv/tou.html\" target=\"_blank\">使用条件</a>をご確認のうえでご利用ください。 当該サービス提供者は当該サービスを無保証で提供しており，当該サービスが原因で発生した損害等について補償等は一切おこないません。 当該サービス提供者は当該サービスを原因とする不具合があった場合でも成果物に関する直接的なサポートを行いません。<br />";
	}
	if (use_ext_tile == true) {
		mapNoteText += extMapSourceNoteProcess3();
	}
	return mapNoteText;
}

// 国土地理院 地理院タイル
// 地理院タイル 標準地図
function GSIstdMapType() {}
	GSIstdMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIstdMapType.prototype.maxZoom = 18; // 0～18→標準地図
	GSIstdMapType.prototype.name = "地理院地図";
	GSIstdMapType.prototype.alt = "国土地理院の標準地図を見る";
	GSIstdMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 淡色地図
function GSIpaleMapType() {}
	GSIpaleMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIpaleMapType.prototype.minZoom = 2;
	GSIpaleMapType.prototype.maxZoom = 18; // 2～18→淡色地図
	GSIpaleMapType.prototype.name = "地理院淡色";
	GSIpaleMapType.prototype.alt = "国土地理院の淡色地図を見る";
	GSIpaleMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/pale/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 英語版地図
function GSIenglishMapType() {}
	GSIenglishMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIenglishMapType.prototype.maxZoom = 18; // ～4→標準地図，5～11→英語地図，12～18→標準地図
	GSIenglishMapType.prototype.name = "GSI Maps";
	GSIenglishMapType.prototype.alt = "GSI Maps (English version)";
	GSIenglishMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 5) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else if (zoom < 12) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/english/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 色別標高図
function GSIreliefMapType() {}
	GSIreliefMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIreliefMapType.prototype.minZoom = 5;  // (～4→標準地図)
	GSIreliefMapType.prototype.maxZoom = 15; // 5～15→色別標高図
	GSIreliefMapType.prototype.name = "段彩陰影";
	GSIreliefMapType.prototype.alt = "国土地理院の色別標高図を見る";
	GSIreliefMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 5) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/relief/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 土地条件
function GSIlcm25kMapType() {}
	GSIlcm25kMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIlcm25kMapType.prototype.minZoom = 4;  // (～3→標準地図)
	GSIlcm25kMapType.prototype.maxZoom = 16; // 4～9→整備範囲，10～16→土地条件図
	GSIlcm25kMapType.prototype.name = "土地条件";
	GSIlcm25kMapType.prototype.alt = "国土地理院の数値地図25000(土地条件)を見る";
	GSIlcm25kMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/pale/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 3 && zoom < 17) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/lcm25k_2012/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			if (zoom < 12) {
				img2.onerror = function() { this.style.display = "none"; }
			} else {
				img2.onerror = function() { this.src = "tile_nodata.gif"; }
			}
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 土地利用（近畿圏2008年，中部圏2003年，首都圏2005年）
function GSIlum4blMapType() {}
	GSIlum4blMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIlum4blMapType.prototype.minZoom = 4;  // (0→標準地図)
	GSIlum4blMapType.prototype.maxZoom = 16; // 1～12→整備範囲，13～16→土地利用図
	GSIlum4blMapType.prototype.name = "土地利用";
	GSIlum4blMapType.prototype.alt = "国土地理院の数値地図5000(土地利用)を見る";
	GSIlum4blMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 13) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/pale/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else if (tile_x_r < 0.8778) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_kinki2008/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else if (tile_x_r < 0.8815) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_chubu2003/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_capital2005/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.style.backgroundColor='#ffffff';
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if ( (zoom > 9) && (zoom < 13) ) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			if (tile_x_r < 0.8778) {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_kinki2008/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			} else if (tile_x_r < 0.8815) {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_chubu2003/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			} else {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_capital2005/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			}
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		} else if (zoom < 10) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_kinki2008/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
			var img3 = ownerDocument.createElement("img");
			img3.style.position = "absolute";
			img3.style.width = this.tileSize.width + "px";
			img3.style.height = this.tileSize.height + "px";
			img3.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_chubu2003/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img3.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img3);
			var img4 = ownerDocument.createElement("img");
			img4.style.position = "absolute";
			img4.style.width = this.tileSize.width + "px";
			img4.style.height = this.tileSize.height + "px";
			img4.src = "//cyberjapandata.gsi.go.jp/xyz/lum4bl_capital2005/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img4.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img4);
		}
		return divLayers;
	};
// 地理院タイル 白地図
function GSIblankMapType() {}
	GSIblankMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIblankMapType.prototype.minZoom = 5;  // 5～14→白地図
	GSIblankMapType.prototype.maxZoom = 18; // 15～18→淡色地図
	GSIblankMapType.prototype.name = "白地図";
	GSIblankMapType.prototype.alt = "白地図を見る";
	GSIblankMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 5) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/pale/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/blank/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/pale/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 写真（シームレス空中写真）
function GSIphotoMapType() {}
	GSIphotoMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIphotoMapType.prototype.minZoom = 2;
	GSIphotoMapType.prototype.maxZoom = 18;
	GSIphotoMapType.prototype.name = "地理院写真";
	GSIphotoMapType.prototype.alt = "国土地理院の空中写真(シームレス空中写真)を見る";
	GSIphotoMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/seamlessphoto/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 電子国土基本図（オルソ画像）＋衛星画像
function GSIortMapType() {}
	GSIortMapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIortMapType.prototype.minZoom = 2;
	GSIortMapType.prototype.maxZoom = 18; // ～4→世界衛星モザイク，5～12→ランドサット，13～18→オルソ画像
	GSIortMapType.prototype.name = "地理院オルソ";
	GSIortMapType.prototype.alt = "国土地理院の空中写真(オルソ画像)を見る";
	GSIortMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/ort/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 電子国土基本図（オルソ画像）＋オルソ整備範囲
function GSIort2MapType() {}
	GSIort2MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIort2MapType.prototype.maxZoom = 18; // ～4→標準地図，5～12(14まで可)→整備範囲，(10から可)13～18→オルソ画像
	GSIort2MapType.prototype.name = "写真最新";
	GSIort2MapType.prototype.alt = "国土地理院オルソ画像(2007年～)を見る";
	GSIort2MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 14) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/ort/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 14) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/photoarea/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 簡易空中写真（2004年～）
function GSIairMapType() {}
	GSIairMapType.prototype.tileSize = new google.maps.Size(256,256);
//	GSIairMapType.prototype.minZoom = 15;
	GSIairMapType.prototype.maxZoom = 18; // ～4→標準地図，5～14→整備範囲，15～18→簡易空中写真
	GSIairMapType.prototype.name = "簡易写真";
	GSIairMapType.prototype.alt = "国土地理院の簡易空中写真(2004年～)を見る";
	GSIairMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/airphoto/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 15) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/airphoto/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 国土画像情報（第１期）
function GSIgazo1MapType() {}
	GSIgazo1MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIgazo1MapType.prototype.maxZoom = 17; // ～4→標準地図，5～9(14まで可)→整備範囲，10～17→国土画像情報
	GSIgazo1MapType.prototype.name = "写真1975";
	GSIgazo1MapType.prototype.alt = "国土画像情報(1974年～1978年撮影)を見る";
	GSIgazo1MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 10) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/gazo1/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 10) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo1area/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 国土画像情報（第２期）
function GSIgazo2MapType() {}
	GSIgazo2MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIgazo2MapType.prototype.maxZoom = 17; // ～4→標準地図，5～9(14まで可)→整備範囲，10～17→国土画像情報
	GSIgazo2MapType.prototype.name = "写真1980";
	GSIgazo2MapType.prototype.alt = "国土画像情報(1979年～1983年撮影)を見る";
	GSIgazo2MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/gazo2/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 15) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			if (zoom < 10) {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo2area/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			} else {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo2/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
			}
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 国土画像情報（第３期）
function GSIgazo3MapType() {}
	GSIgazo3MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIgazo3MapType.prototype.maxZoom = 17; // ～4→標準地図，5～9(14まで可)→整備範囲，10～17→国土画像情報
	GSIgazo3MapType.prototype.name = "写真1985";
	GSIgazo3MapType.prototype.alt = "国土画像情報(1984年～1986年撮影)を見る";
	GSIgazo3MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/gazo3/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 15) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			if (zoom < 10) {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo3area/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			} else {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo3/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
			}
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 国土画像情報（第４期）
function GSIgazo4MapType() {}
	GSIgazo4MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIgazo4MapType.prototype.maxZoom = 17; // ～4→標準地図，5～9(14まで可)→整備範囲，10～17→国土画像情報
	GSIgazo4MapType.prototype.name = "写真1990";
	GSIgazo4MapType.prototype.alt = "国土画像情報(1988年～1990年撮影)を見る";
	GSIgazo4MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/gazo4/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 15) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			if (zoom < 10) {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo4area/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			} else {
				img2.src = "//cyberjapandata.gsi.go.jp/xyz/gazo4/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".jpg";
			}
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 空中写真（1961～1964年）
function GSIortOld10MapType() {}
	GSIortOld10MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIortOld10MapType.prototype.maxZoom = 17; // ～4→標準地図，5～14→整備範囲，15～17→空中写真
	GSIortOld10MapType.prototype.name = "写真1963";
	GSIortOld10MapType.prototype.alt = "空中写真(1961年～1964年撮影)を見る";
	GSIortOld10MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/ort_old10/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 15) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/ort_old10/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 地理院タイル 空中写真（1945～1950年）
function GSIortUSA10MapType() {}
	GSIortUSA10MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSIortUSA10MapType.prototype.maxZoom = 17; // ～4→標準地図，5～14→整備範囲，15～17→空中写真
	GSIortUSA10MapType.prototype.name = "写真1947";
	GSIortUSA10MapType.prototype.alt = "空中写真(米軍1945年～1950年撮影)を見る";
	GSIortUSA10MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//cyberjapandata.gsi.go.jp/xyz/ort_USA10/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if (zoom > 4 && zoom < 15) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//cyberjapandata.gsi.go.jp/xyz/ort_USA10/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 農研機構 Finds.jp 基盤地図情報WMS配信サービスの利用
// Finds.jp 基盤地図情報 縮尺レベル25000
function Kiban25000MapType() {}
	Kiban25000MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kiban25000MapType.prototype.maxZoom = 18;
	Kiban25000MapType.prototype.name = "基盤地図25000";
	Kiban25000MapType.prototype.alt = "基盤地図情報(縮尺レベル25000)を見る";
	Kiban25000MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN25000ANF-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// Finds.jp 基盤地図情報 縮尺レベル2500
function Kiban2500MapType() {}
	Kiban2500MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kiban2500MapType.prototype.maxZoom = 20;
	Kiban2500MapType.prototype.name = "基盤地図2500";
	Kiban2500MapType.prototype.alt = "基盤地図情報(縮尺レベル2500)を見る";
	Kiban2500MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 15) {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN25000ANF-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN2500FN-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img.style.backgroundColor='#ffffff';
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// Finds.jp 基盤地図情報 縮尺レベル25000と縮尺レベル2500の連結（縮尺レベル25000主体）
function Kiban25000aMapType() {}
	Kiban25000aMapType.prototype.tileSize = new google.maps.Size(256,256);
	Kiban25000aMapType.prototype.maxZoom = 20;
	Kiban25000aMapType.prototype.name = "基盤地図";
	Kiban25000aMapType.prototype.alt = "基盤地図情報を見る";
	Kiban25000aMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 18) {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN25000ANF-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN2500FN-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img.style.backgroundColor='#ffffff';
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// Finds.jp 基盤地図情報 縮尺レベル25000等高線
function Kiban25000cMapType() {}
	Kiban25000cMapType.prototype.tileSize = new google.maps.Size(256,256);
	Kiban25000cMapType.prototype.maxZoom = 18;
	Kiban25000cMapType.prototype.name = "等高線";
	Kiban25000cMapType.prototype.alt = "基盤地図情報による等高線図を見る";
	Kiban25000cMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		if (zoom < 14) {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN25000ANF-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		} else {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/KBN25000CNB-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
			img.style.backgroundColor='#ffffff';
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// Finds.jp 歴史的農業環境WMS配信サービス（関東平野迅速測図）
function FindsHawmsKantoMapType() {}
	FindsHawmsKantoMapType.prototype.tileSize = new google.maps.Size(256,256);
	FindsHawmsKantoMapType.prototype.maxZoom = 17;
	FindsHawmsKantoMapType.prototype.name = "明治迅速";
	FindsHawmsKantoMapType.prototype.alt = "明治初期の地図(迅速測図)を見る";
	FindsHawmsKantoMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//www.finds.jp/ws/tmc/1.0.0/Kanto_Rapid-900913-L/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 今昔マップ 明治２万 ＋ Finds.jp 歴史的農業環境WMS配信サービス（福山）
function Kjmap2manMapType() {}
	Kjmap2manMapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap2manMapType.prototype.minZoom = 8;
	Kjmap2manMapType.prototype.maxZoom = 16;
	Kjmap2manMapType.prototype.name = "明治２万";
	Kjmap2manMapType.prototype.alt = "明治後期の地図(２万分１)を見る";
	Kjmap2manMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if (tile_x_r < 0.871) {
			img.src = "//www.finds.jp/ws/tmc/1.0.0/Fukuyama_1899-900913/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.878) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/keihansin/2man/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.8837) {
			if (tile_x_r < 0.88111) {
				img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/chukyo/2man/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			} else {
				img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hamamatsu/2man/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			}
		} else {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tokyo50/2man/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if ( (tile_x_r > 0.878) && (tile_x_r < 0.8837) && (tile_y_r > 0.6015) && (tile_y_r < 0.60346) ) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hamamatsu/2man/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 今昔マップ 25000  1920
function Kjmap25k1920MapType() {}
	Kjmap25k1920MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap25k1920MapType.prototype.minZoom = 8;
	Kjmap25k1920MapType.prototype.maxZoom = 16;
	Kjmap25k1920MapType.prototype.name = "地図1920";
	Kjmap25k1920MapType.prototype.alt = "1920年頃の地図(2.5万分1)を見る";
	Kjmap25k1920MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if (tile_y_r < 0.578) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/okinawas/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.865) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/fukuoka/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.871) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hiroshima/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.878) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/keihansin/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.8837) {
			if (tile_x_r < 0.88125) {
				img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/chukyo/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			} else {
				img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hamamatsu/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			}
		} else if (tile_y_r < 0.612) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tokyo50/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_y_r < 0.625) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sendai/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sapporo/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if ( (tile_x_r > 0.878) && (tile_x_r < 0.88367) && (tile_y_r > 0.6015) && (tile_y_r < 0.60363) ) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hamamatsu/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 今昔マップ 25000  1930
function Kjmap25k1930MapType() {}
	Kjmap25k1930MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap25k1930MapType.prototype.minZoom = 8;
	Kjmap25k1930MapType.prototype.maxZoom = 16;
	Kjmap25k1930MapType.prototype.name = "地図1930";
	Kjmap25k1930MapType.prototype.alt = "1930年頃の地図(2.5万分1)を見る";
	Kjmap25k1930MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if (tile_x_r < 0.865) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/fukuoka/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.871) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hiroshima/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.878) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/keihansin/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.882) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/chukyo/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_y_r < 0.612) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tokyo50/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_y_r < 0.625) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sendai/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sapporo/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 今昔マップ 25000  1950
function Kjmap25k1950MapType() {}
	Kjmap25k1950MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap25k1950MapType.prototype.minZoom = 8;
	Kjmap25k1950MapType.prototype.maxZoom = 16;
	Kjmap25k1950MapType.prototype.name = "地図1950";
	Kjmap25k1950MapType.prototype.alt = "1950年頃の地図(2.5万分1)を見る";
	Kjmap25k1950MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if (tile_x_r < 0.865) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/fukuoka/02/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.871) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hiroshima/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.878) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/keihansin/02/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.8837) {
			if (tile_x_r < 0.88125) {
				img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/chukyo/03/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			} else {
				img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hamamatsu/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			}
		} else if (tile_y_r < 0.612) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tokyo50/02/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_y_r < 0.625) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sendai/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sapporo/02/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		if ( (tile_x_r > 0.878) && (tile_x_r < 0.88367) && (tile_y_r > 0.6015) && (tile_y_r < 0.60363) ) {
			var img2 = ownerDocument.createElement("img");
			img2.style.position = "absolute";
			img2.style.width = this.tileSize.width + "px";
			img2.style.height = this.tileSize.height + "px";
			img2.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hamamatsu/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			img2.onerror = function() { this.style.display = "none"; }
			divLayers.appendChild(img2);
		}
		return divLayers;
	};
// 今昔マップ 25000  1970
function Kjmap25k1970MapType() {}
	Kjmap25k1970MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap25k1970MapType.prototype.minZoom = 8;
	Kjmap25k1970MapType.prototype.maxZoom = 16;
	Kjmap25k1970MapType.prototype.name = "地図1970";
	Kjmap25k1970MapType.prototype.alt = "1970年頃の地図(2.5万分1)を見る";
	Kjmap25k1970MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if (tile_y_r < 0.578) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/okinawas/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.865) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/fukuoka/03/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.871) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/hiroshima/02/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.878) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/keihansin/04/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_x_r < 0.882) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/chukyo/05/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_y_r < 0.612) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tokyo50/03/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else if (tile_y_r < 0.625) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sendai/02/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else {
//			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/sapporo/03/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
			img.src = "tile_nodata.gif";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 今昔マップ 50000  1910
function Kjmap50k1910MapType() {}
	Kjmap50k1910MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap50k1910MapType.prototype.minZoom = 8;
	Kjmap50k1910MapType.prototype.maxZoom = 15;
	Kjmap50k1910MapType.prototype.name = "明治大正(5万)";
	Kjmap50k1910MapType.prototype.alt = "明治後期～大正期(1894～1915頃)の地図(５万分１)を見る";
	Kjmap50k1910MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if ( (tile_x_r < 0.890625) || (tile_y_r < 0.609375) ) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/kanto/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tohoku_pacific_coast/00/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 今昔マップ 50000  1940
function Kjmap50k1940MapType() {}
	Kjmap50k1940MapType.prototype.tileSize = new google.maps.Size(256,256);
	Kjmap50k1940MapType.prototype.minZoom = 8;
	Kjmap50k1940MapType.prototype.maxZoom = 15;
	Kjmap50k1940MapType.prototype.name = "昭和前期(5万)";
	Kjmap50k1940MapType.prototype.alt = "昭和前期(1930～1950頃)の地図(５万分１)を見る";
	Kjmap50k1940MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		if ( (tile_x_r < 0.890625) || (tile_y_r < 0.609375) ) {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/kanto/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		} else {
			img.src = "//sv53.wadax.ne.jp/~ktgis-net/kjmapw/kjtilemap/tohoku_pacific_coast/01/" + zoom + "/" + tile_x + "/" + tile_y + ".png";
		}
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 国土地理院 地理院タイル【災害対応等】
// 地理院タイル 東日本大震災被災地オルソ画像（震災直後）
function GSItoho1MapType() {}
	GSItoho1MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSItoho1MapType.prototype.minZoom = 15;
	GSItoho1MapType.prototype.maxZoom = 17; // 15～17 (現在の提供範囲)
	GSItoho1MapType.prototype.name = "東日本写真(震災直後)";
	GSItoho1MapType.prototype.alt = "東日本大震災被災地 震災直後オルソ画像（2011.3～2011.4撮影）を見る";
	GSItoho1MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/toho1/" + zoom + "/" + tileCoord.x + "/" + tileCoord.y + ".jpg";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// 地理院タイル 東日本大震災被災地オルソ画像（震災後）
function GSItoho2MapType() {}
	GSItoho2MapType.prototype.tileSize = new google.maps.Size(256,256);
	GSItoho2MapType.prototype.minZoom = 15;
	GSItoho2MapType.prototype.maxZoom = 18; // 15～18 (現在の提供範囲)
	GSItoho2MapType.prototype.name = "東日本写真(震災後)";
	GSItoho2MapType.prototype.alt = "東日本大震災被災地 震災後オルソ画像（2011.5～2012.4撮影）を見る";
	GSItoho2MapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var img = ownerDocument.createElement("img");
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/toho2/" + zoom + "/" + tileCoord.x + "/" + tileCoord.y + ".jpg";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		return img;
	};
// その他
// タイル座標表示 原点：北西 (Google Maps API)
function CoordinateMapType() {}
	CoordinateMapType.prototype.tileSize = new google.maps.Size(256,256);
	CoordinateMapType.prototype.maxZoom = 19;
	CoordinateMapType.prototype.name = "タイル座標";
	CoordinateMapType.prototype.alt = "地図のタイル座標（原点：北西）を表示し，タイルの輪郭を描画します。";
	CoordinateMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_x_r = tileCoord.x / Math.pow(2, zoom);
		var tile_y_r = tileCoord.y / Math.pow(2, zoom);
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		var div2 = ownerDocument.createElement("div");
		div2.style.position = "absolute";
		div2.style.width = this.tileSize.width + "px";
		div2.style.height = this.tileSize.height + "px";
		div2.innerHTML = "z=" + zoom + "<br />x=" + tileCoord.x + " (" + tile_x_r + ")<br />y=" + tileCoord.y + " (" + tile_y_r + ")";
		div2.style.fontSize = '150%';
		div2.style.backgroundColor='rgba(255,255,255,0.5)';
		div2.style.borderStyle = 'solid';
		div2.style.borderWidth = '1px';
		div2.style.borderColor = '#aaaaaa';
		divLayers.appendChild(div2);
		return divLayers;
	};
// タイル座標表示 原点：南西 (TMS)
function CoordinateSwMapType() {}
	CoordinateSwMapType.prototype.tileSize = new google.maps.Size(256,256);
	CoordinateSwMapType.prototype.maxZoom = 19;
	CoordinateSwMapType.prototype.name = "タイル座標(TMS)";
	CoordinateSwMapType.prototype.alt = "地図のタイル座標（原点：南西）を表示し，タイルの輪郭を描画します。";
	CoordinateSwMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var tile_x = tileCoord.x % Math.pow(2, zoom);
		if (tile_x < 0) {
			tile_x += Math.pow(2, zoom);
		}
		var tile_y = Math.pow(2, zoom) - tileCoord.y - 1;
		var tile_x_r = tile_x / Math.pow(2, zoom);
		var tile_y_r = tile_y / Math.pow(2, zoom);
		var divLayers = ownerDocument.createElement("div");
		divLayers.style.position = "relative";
		var img = ownerDocument.createElement("img");
		img.style.position = "absolute";
		img.style.width = this.tileSize.width + "px";
		img.style.height = this.tileSize.height + "px";
		img.src = "//cyberjapandata.gsi.go.jp/xyz/std/" + zoom + "/" + tile_x + "/" + tileCoord.y + ".png";
		img.onerror = function() { this.src = "tile_nodata.gif"; }
		divLayers.appendChild(img);
		var div2 = ownerDocument.createElement("div");
		div2.style.position = "absolute";
		div2.style.width = this.tileSize.width + "px";
		div2.style.height = this.tileSize.height + "px";
		div2.style.backgroundColor='rgba(255,255,255,0.5)';
		div2.style.borderStyle = 'solid';
		div2.style.borderWidth = '1px';
		div2.style.borderColor = '#aaaaaa';
		var div2child = ownerDocument.createElement("div");
		div2child.style.position = "absolute";
		div2child.style.bottom = "0px";
		div2child.innerHTML = "z=" + zoom + "<br />x=" + tileCoord.x + " (" + tile_x_r + ")<br />y=" + tile_y + " (" + tile_y_r + ")";
		div2child.style.fontSize = '150%';
		div2.appendChild(div2child);
		divLayers.appendChild(div2);
		return divLayers;
	};
// 全面白色の地図タイル (背景地図なし)
function WhiteMapType() {}
	WhiteMapType.prototype.tileSize = new google.maps.Size(256,256);
	WhiteMapType.prototype.maxZoom = 19;
	WhiteMapType.prototype.name = "背景地図なし";
	WhiteMapType.prototype.alt = "背景地図を表示しない";
	WhiteMapType.prototype.getTile = function(tileCoord, zoom, ownerDocument) {
		var div = ownerDocument.createElement("div");
		div.style.position = "absolute";
		div.style.width = this.tileSize.width + "px";
		div.style.height = this.tileSize.height + "px";
		// div.innerHTML = "";
		div.style.backgroundColor='rgba(255,255,255,1.0)';
		return div;
	};

function load() {
//	if (url_arg["file"].match(/^\S+$/)) {
	if (data_file.match(/^[\w\-][\w\-\.]*$/)) {
		if ( data_file.match(/\.$/) ) {  // ファイル名末尾がピリオド
			data_file += "txt";
		}
//		if ( !(data_file.split('/')[data_file.split('/').length - 1].match(/\./)) ) {  // ファイル名に拡張子なし
		if ( !(data_file.match(/\./)) ) {  // ファイル名に拡張子なし
			data_file += ".txt";
		}
		if ( !(data_file.match(/\.txt$/i)) ) {  // ファイル名末尾が .txt 以外
		//	data_file += ".txt";
		}
	} else {
		data_file = "";
	}
	if (data_dir.match(/^\S+$/)) {
		if ( !(data_dir.match(/\/$/)) ) {  // ディレクトリ名末尾がスラッシュ以外
			data_dir += "/";
		}
	} else {
		data_dir = "";
	}
	if (location.href.match(/^\w+\:\/\/\S+$/)) {
		if ( location.href.match(/^\w+\:\/\/.*[^\/][\/]/) ) {
			default_url = location.href.match(/^\w+\:\/\/.*[^\/][\/]/)[0];
		} else {
			default_url = location.href + "/";
		}
	} else {
		default_url = "";
	}
	map_type_id = mapTypeIdFromNameWord(map_type_preset);
	if (map_type_id == null) {
		map_type_id = google.maps.MapTypeId.ROADMAP;
	}
	getUrlArg(); // URL引数による地点等の指定を可能にする。
	// 地図の初期設定
	var map_options = {
		zoom: map_zoom,
		center: new google.maps.LatLng(center_lat, center_lng),
		mapTypeId: map_type_id,
		scaleControl: true,
		clickableIcons: false
	};
	map = new google.maps.Map(document.getElementById("map_canvas"), map_options);
	map.setTilt(0);
	// マップタイプ設定
	map.mapTypes.set("GSIstd", new GSIstdMapType);
	map.mapTypes.set("GSIpale", new GSIpaleMapType);
	map.mapTypes.set("GSIenglish", new GSIenglishMapType);
	map.mapTypes.set("GSIrelief", new GSIreliefMapType);
	map.mapTypes.set("GSIlcm25k", new GSIlcm25kMapType);
	map.mapTypes.set("GSIlum4bl", new GSIlum4blMapType);
	map.mapTypes.set("GSIblank", new GSIblankMapType);
	map.mapTypes.set("GSIphoto", new GSIphotoMapType);
	map.mapTypes.set("GSIort", new GSIortMapType);
	map.mapTypes.set("GSIort2", new GSIort2MapType);
	map.mapTypes.set("GSIair", new GSIairMapType);
	map.mapTypes.set("GSIgazo1", new GSIgazo1MapType);
	map.mapTypes.set("GSIgazo2", new GSIgazo2MapType);
	map.mapTypes.set("GSIgazo3", new GSIgazo3MapType);
	map.mapTypes.set("GSIgazo4", new GSIgazo4MapType);
	map.mapTypes.set("GSIortOld10", new GSIortOld10MapType);
	map.mapTypes.set("GSIortUSA10", new GSIortUSA10MapType);
	map.mapTypes.set("Kiban25000", new Kiban25000MapType);
	map.mapTypes.set("Kiban2500", new Kiban2500MapType);
	map.mapTypes.set("Kiban25000a", new Kiban25000aMapType);
	map.mapTypes.set("Kiban25000c", new Kiban25000cMapType);
	map.mapTypes.set("FindsHawmsKanto", new FindsHawmsKantoMapType);
	map.mapTypes.set("Kjmap2man", new Kjmap2manMapType);
	map.mapTypes.set("Kjmap25k1920", new Kjmap25k1920MapType);
	map.mapTypes.set("Kjmap25k1930", new Kjmap25k1930MapType);
	map.mapTypes.set("Kjmap25k1950", new Kjmap25k1950MapType);
	map.mapTypes.set("Kjmap25k1970", new Kjmap25k1970MapType);
	map.mapTypes.set("Kjmap50k1910", new Kjmap50k1910MapType);
	map.mapTypes.set("Kjmap50k1940", new Kjmap50k1940MapType);
	map.mapTypes.set("GSItoho1", new GSItoho1MapType);
	map.mapTypes.set("GSItoho2", new GSItoho2MapType);
	map.mapTypes.set("Coordinate", new CoordinateMapType);
	map.mapTypes.set("CoordinateSw", new CoordinateSwMapType);
	map.mapTypes.set("White", new WhiteMapType);
	// 外部ファイルによるマップタイプの設定
	if (use_ext_tile == true) {
		extMapTypeSet();
	}
	// マップタイプ初期値に基づくマップタイプ・コントロールの初期設定
	map.setOptions({
		mapTypeControlOptions: {
			mapTypeIds: [map_type_id],
			style: google.maps.MapTypeControlStyle.DEFAULT
		}
	});
	// 地図クレジット表示（地図内）の初期設定
	setMapCreditControl();
	google.maps.event.addListener(map, "maptypeid_changed", function() {
		indicateMapCredit();
	});
	google.maps.event.addListener(map, "zoom_changed", function() {
		indicateMapCredit();
	});
	indicateMapCredit();
	// マップタイプ初期値に基づく地図出典注釈表示（地図外）の初期設定
	if ( document.getElementById("map_source") ) {
		var mapSourceNoteHtml = mapSourceNote(map_type_id);
		if (mapSourceNoteHtml != "") {
			document.getElementById("map_source").innerHTML = '<div style=\"margin-bottom:1em\">［地図について］</div>' + mapSourceNoteHtml;
		} else {
			document.getElementById("map_source").innerHTML = '';
		}
	}
	// マーカー吹き出しの準備
	infowindow = new google.maps.InfoWindow({
		maxWidth: info_window_max_width
	});
	// 画面レイアウトの判定
	if ( document.getElementById("description") ) {
		if ( !(document.getElementById("text_top")) && !(document.getElementById("text_bottom"))) {
			layout_type = 4;
		} else {
			layout_type = 2;
		}
	} else {
		layout_type = 0;
	}
	// 画面レイアウト別に地点属性表示の準備
	if ( (layout_type == 2) || (layout_type == 4) ) {
		google.maps.event.addListener(map, 'click', function() {
			infowindow.close();
			description_reset();
		});
		google.maps.event.addListener(infowindow, 'closeclick', function() {
			description_reset();
		});
	} else {
		google.maps.event.addListener(map, 'click', function() {
			infowindow.close();
		});
	}

	if ( document.getElementById("streetview_canvas") ) {
		document.getElementById("streetview_canvas").style.display="none";
		var streetViewOptions = {
			visible: false,
			enableCloseButton: true
		};
		var streetView = new google.maps.StreetViewPanorama(document.getElementById("streetview_canvas"), streetViewOptions);
		map.setStreetView(streetView);
//		map.bindTo("center", streetView, "position");
		google.maps.event.addListener(streetView, 'visible_changed', function() {
			if (streetView.getVisible() == true) {
				document.getElementById("streetview_canvas").style.display="block";
			} else {
				document.getElementById("streetview_canvas").style.display="none";
			}
		});
		google.maps.event.addListener(streetView, 'position_changed', function() {
			map.setCenter(streetView.getPosition());
		});
	}

	var htmlCacheRefresh = "";
	if (data_file.match(/^\S+$/)) {
		var dataUrl = "";
		if (data_file.match(/^\w+\:/) || data_file.match(/^[\/]/)) {
			dataUrl = data_file;
		} else {
			dataUrl = data_dir + data_file;
		}
		downloadText(dataUrl, evaluateData, false);
		//
		var urlForReload = location.pathname + "?" + location.search.substr(1);
		if ( !(urlForReload.match(/cache=refresh$/)) ) {
			if ( !(urlForReload.match(/\?$/)) ) {
				urlForReload += "&";
			}
			urlForReload += "cache=refresh";
		}
		htmlCacheRefresh = '<a href=\"' + urlForReload + '\">データ再読み込み</a> / <a href=\"' + dataUrl + '\">参照</a>';
	}
	if ( document.getElementById("cache_refresh") ) {
		document.getElementById("cache_refresh").innerHTML = htmlCacheRefresh;
	}
	var htmlVersionInfo = "";
	if (use_ext_tile == true) {
		htmlVersionInfo = script_version_info + ' (' +  script_author_info + ') with ' + ext_tile_script_version_info + ' using Google Maps JavaScript API version ' + google.maps.version;
	} else {
		htmlVersionInfo = script_version_info + ' (' +  script_author_info + ') using Google Maps JavaScript API version ' + google.maps.version;
	}
	if ( document.getElementById("script_version_info") ) {
		document.getElementById("script_version_info").innerHTML = htmlVersionInfo;
	}
	if ( layout_type == 4 ) {
		description4system0 += '<div style=\"margin:1em 0em 0em; color:gray; font-size:60%; line-height:120%;\">';
		description4system0 += htmlVersionInfo;
		description4system0 += '<br />' + htmlCacheRefresh;
		description4system0 += '</div>';
		document.getElementById("description").innerHTML = description4system0;
		document.getElementById("description_canvas").scrollTop = 0;
	}
}

function evaluateData(downloadData) {
	markers[0] = new google.maps.MVCArray();
	groundoverlays[0] = new google.maps.MVCArray();
	groundoverlays_opacity[0] = []; groundoverlays_clickable[0] = [];
	layerName[0] = "";
	if (visibility_marker == true) {
		layerVisibility[0] = true;
	} else {
		layerVisibility[0] = false;
	}
	layerIncludeGpx[0] = false;
	var textPageHeadTitle = ""; var textPageTopHtml =""; var textPageBottomHtml = "";
	var textPageRightHtml = ""; var textPageFullHtml = "";
	var mapTypeIdsArray = [];
	var mapTypeControlStyle = "";
	var zoom_request = null; var zoom_request_2 = null; var zoom_request_3 = null;
	var lat = ""; var lng = ""; var attr = ""; var titl = ""; var html = "";
	var obj_type = ""; var data_hold = false;
	var rowdata = downloadData.split(/[\r\n]+/);
	for (var i = 0 ; i < rowdata.length ; i++) {
	if ( (rowdata[i].length > 0) && !(rowdata[i].match(/^\s*;/)) ) {
		rowdata[i] += "\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
		var coldata = rowdata[i].split('\t',15);
		if ( (coldata[1].toLowerCase() != "continue")
				&& (coldata[1].toLowerCase() != "cont.")
				&& (coldata[1].toLowerCase() != "cont") ) {
			if (data_hold == true) {
				addMarker(obj_type, lat, lng, attr, titl, html, layerNum);
				obj_type = ""; lat = ""; lng = ""; attr = ""; titl = ""; html = "";
				data_hold = false;
			}
			if ( ( coldata[1].toLowerCase() == "map" )
					|| (coldata[1].toLowerCase() == "view") )  {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					center_lat = coldata[2];
					center_lng = coldata[3];
				}
				if ( (coldata[4] != "") && !(isNaN(coldata[4]-0)) ) {
					if (parseInt(coldata[4], 10) >= 0) {
						zoom_request = parseInt(coldata[4], 10);
					}
				}
				if (coldata[5] != "") {
					if (mapTypeIdFromNameWord(coldata[5]) != null) {
						map_type_id = mapTypeIdFromNameWord(coldata[5]);
					}
				}
			} else if (coldata[1].toLowerCase() == "zoom") {
				obj_type = "zoom";
				zoom_request_2 = null;
				zoom_request_3 = null;
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0)) ) {
					zoom_request_2 = parseInt(coldata[2], 10);
					if ( zoom_request_2 < 0 ) {
						zoom_request_2 = null;
					}
				}
				if ( (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					zoom_request_3 = parseInt(coldata[3], 10);
					if ( zoom_request_3 < 0 ) {
						zoom_request_3 = null;
					}
				}
			} else if ( (coldata[1].toLowerCase() == "maptype")
					|| (coldata[1].toLowerCase() == "map type") ) {
				obj_type = "maptype";
				if (coldata[2] != "") {
					if (mapTypeIdFromNameWord(coldata[2]) != null) {
						mapTypeIdsArray.push(mapTypeIdFromNameWord(coldata[2]));
					}
				}
				if (coldata[3] != "") {
					if (mapTypeIdFromNameWord(coldata[3]) != null) {
						mapTypeIdsArray.push(mapTypeIdFromNameWord(coldata[3]));
					}
				}
			} else if ( (coldata[1].toLowerCase() == "maptypecontrol")
					|| (coldata[1].toLowerCase() == "maptypecontrolstyle") ) {
				obj_type = "maptypecontrol";
				switch ( coldata[2].toLowerCase() ) {
					case "horizotal":
					case "horizotal_bar":
					case "horizotal bar":
						mapTypeControlStyle = google.maps.MapTypeControlStyle.HORIZONTAL_BAR;
						break;
					case "dropdown":
					case "dropdown_menu":
					case "dropdown menu":
						mapTypeControlStyle = google.maps.MapTypeControlStyle.DROPDOWN_MENU;
						break;
					case "default":
					case "auto":
						mapTypeControlStyle = google.maps.MapTypeControlStyle.DEFAULT;
						break;
				}
			} else if (coldata[1].toLowerCase() == "search") {
				if (coldata[2].toLowerCase() == "yes") {
					use_search_box = true;
				} else if (coldata[2].toLowerCase() == "no") {
					use_search_box = false;
				}
			} else if (coldata[1].toLowerCase() == "linkurl") {
				if (coldata[2].toLowerCase() == "yes") {
					use_link_url = true;
				} else if (coldata[2].toLowerCase() == "no") {
					use_link_url = false;
				}
			} else if ( (coldata[1].toLowerCase() == "side")
					|| (coldata[1].toLowerCase() == "sidebar") ) {
				if (coldata[2].toLowerCase() == "yes") {
					sideBarVisibility = true;
				} else if (coldata[2].toLowerCase() == "no") {
					sideBarVisibility = false;
				}
			} else if ((coldata[1].toLowerCase() == "page") && (coldata[2].toLowerCase() == "title")) {
				if ((coldata[3].toLowerCase() == "") || (coldata[3].toLowerCase() == "goma") || (coldata[3].toLowerCase() == "google")) {
					textPageHeadTitle = coldata[9];
				}
			} else if ((coldata[1].toLowerCase() == "page") && (coldata[2].toLowerCase() == "top")) {
				if ((coldata[3].toLowerCase() == "") || (coldata[3].toLowerCase() == "goma") || (coldata[3].toLowerCase() == "google")) {
					obj_type = "page_top";
					textPageTopHtml += createInfoHtmlForPage(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
				}
			} else if ((coldata[1].toLowerCase() == "page") && (coldata[2].toLowerCase() == "bottom")) {
				if ((coldata[3].toLowerCase() == "") || (coldata[3].toLowerCase() == "goma") || (coldata[3].toLowerCase() == "google")) {
					obj_type = "page_bottom";
					textPageBottomHtml += createInfoHtmlForPage(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
				}
			} else if ((coldata[1].toLowerCase() == "page") && (coldata[2].toLowerCase() == "right")) {
				if ((coldata[3].toLowerCase() == "") || (coldata[3].toLowerCase() == "goma") || (coldata[3].toLowerCase() == "google")) {
					obj_type = "page_right";
					textPageRightHtml += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
				}
			} else if ((coldata[1].toLowerCase() == "page") && (coldata[2].toLowerCase() == "full")) {
				if ((coldata[3].toLowerCase() == "") || (coldata[3].toLowerCase() == "goma") || (coldata[3].toLowerCase() == "google")) {
					obj_type = "page_full";
					textPageFullHtml += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
				}
			} else if ( (coldata[1].toLowerCase() == "message")
					|| (coldata[1].toLowerCase() == "balloon") ) {
				obj_type = "message";
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					lat  = coldata[2];
					lng  = coldata[3];
				}
				html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
				data_hold = true;
			} else if (coldata[1].toLowerCase() == "layer") {
				obj_type = "layer";
				layerNum += 1;
				markers[layerNum] = new google.maps.MVCArray();
				groundoverlays[layerNum] = new google.maps.MVCArray();
				groundoverlays_opacity[layerNum] = []; groundoverlays_clickable[layerNum] = [];
				if ( (coldata[2] != "") && (coldata[2].match(/^\S+$/)) ) {
					layerName[layerNum] = coldata[2];
				} else {
					layerName[layerNum] = 'レイヤ ' + layerNum;
				}
				if (visibility_marker == false) {
					layerVisibility[layerNum] = false;
				} else if (coldata[3].toLowerCase() == "yes") {
					layerVisibility[layerNum] = true;
				} else if (coldata[3].toLowerCase() == "no") {
					layerVisibility[layerNum] = false;
				} else {
					layerVisibility[layerNum] = true;
				}
				layerIncludeGpx[layerNum] = false;
			} else if ( (coldata[1].toLowerCase() == "marker")
					|| (coldata[1].toLowerCase() == "icon") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					obj_type = "marker";
					lat  = coldata[2];
					lng  = coldata[3];
					attr = coldata[4];
					titl = coldata[5];
					html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
					data_hold = true;
				}
			} else if ( (coldata[1].toLowerCase() == "circle")
					|| (coldata[1].toLowerCase() == "buffer") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					obj_type = "circle";
					lat = new google.maps.LatLng(coldata[2], coldata[3]);
					lng = "";
					attr = coldata[4];
					titl = coldata[5];
					html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
					data_hold = true;
				}
			} else if ( (coldata[1].toLowerCase() == "polyline")
					|| (coldata[1].toLowerCase() == "line") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					obj_type = "polyline";
					lat = [];
					lat.push(new google.maps.LatLng(coldata[2], coldata[3]));
					lng = "";
					attr = coldata[4];
					titl = coldata[5];
					html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
					data_hold = true;
				}
			} else if ( (coldata[1].toLowerCase() == "polygon")
					|| (coldata[1].toLowerCase() == "poly") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					obj_type = "polygon";
					lat = [];
					lat.push(new google.maps.LatLng(coldata[2], coldata[3]));
					lng = "";
					attr = coldata[4];
					titl = coldata[5];
					html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
					data_hold = true;
				}
			} else if ( (coldata[1].toLowerCase() == "rectangle")
					|| (coldata[1].toLowerCase() == "rect") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					obj_type = "rectangle";
					lat = new google.maps.LatLng(coldata[2], coldata[3]);
					lng = "";
					attr = coldata[4];
					titl = coldata[5];
					html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
					data_hold = true;
				}
			} else if ( (coldata[1].toLowerCase() == "groundoverlay")
					|| (coldata[1].toLowerCase() == "ground")
					|| (coldata[1].toLowerCase() == "overlay") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0))
						&& (coldata[5].match(/^\S+$/)) ) {
					obj_type = "groundoverlay";
					lat = new google.maps.LatLng(coldata[2], coldata[3]);
					lng = "";
					attr = coldata[4];
					titl = coldata[5];
					html = createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
					data_hold = true;
				}
			} else if ( (coldata[1].toLowerCase() == "gpx")
					|| (coldata[1].toLowerCase() == "gps") ) {
				layerIncludeGpx[layerNum] = true;
				accessGpx(coldata[2], layerNum, coldata[3]);
			} else if ( (coldata[1].toLowerCase() == "kml")
					|| (coldata[1].toLowerCase() == "georss") ) {
				renderKml(coldata[2], coldata[3], coldata[4]);
			} else if ( (coldata[1].toLowerCase() == "geojson")
					|| (coldata[1].toLowerCase() == "json") ) {
				accessJson(coldata[2], coldata[3], coldata[4], coldata[5]);
			}
		} else {  // "continue" の場合
			if (obj_type == "maptype") {
				if (coldata[2] != "") {
					if (mapTypeIdFromNameWord(coldata[2]) != null) {
						mapTypeIdsArray.push(mapTypeIdFromNameWord(coldata[2]));
					}
				}
				if (coldata[3] != "") {
					if (mapTypeIdFromNameWord(coldata[3]) != null) {
						mapTypeIdsArray.push(mapTypeIdFromNameWord(coldata[3]));
					}
				}
			} else if (obj_type == "page_top") {
				textPageTopHtml += createInfoHtmlForPage(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if (obj_type == "page_bottom") {
				textPageBottomHtml += createInfoHtmlForPage(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if (obj_type == "page_right") {
				textPageRightHtml += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if (obj_type == "page_full") {
				textPageFullHtml += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "message") ) {
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "marker") ) {
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "circle") ) {
				if ( (lng == "")
						&& (coldata[2] != "") && !(isNaN(coldata[2]-0)) ) {
					lng = coldata[2] * 1000;
				}
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "polyline") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					lat.push(new google.maps.LatLng(coldata[2], coldata[3]));
				}
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "polygon") ) {
				if ( (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					lat.push(new google.maps.LatLng(coldata[2], coldata[3]));
				}
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "rectangle") ) {
				if ( (lng == "")
						&& (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					lng = new google.maps.LatLng(coldata[2], coldata[3]);
				}
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			} else if ( (data_hold == true) && (obj_type == "groundoverlay") ) {
				if ( (lng == "")
						&& (coldata[2] != "") && !(isNaN(coldata[2]-0))
						&& (coldata[3] != "") && !(isNaN(coldata[3]-0)) ) {
					lng = new google.maps.LatLng(coldata[2], coldata[3]);
				}
				html += createInfoHtml(coldata[6], coldata[7], coldata[8], coldata[9], coldata[10], coldata[11], coldata[12], coldata[13], coldata[14]);
			}
		}
	}
	}
	if (data_hold == true) {
		addMarker(obj_type, lat, lng, attr, titl, html, layerNum);
		obj_type = ""; lat = ""; lng = ""; attr = ""; titl = ""; html = "";
		data_hold = false;
	}

	if ( (zoom_request_2 != null) && (zoom_request_3 != null)
			&& (zoom_request_2 < zoom_request_3) ) {
		var zoom_request_2_temp = zoom_request_2;
		var zoom_request_3_temp = zoom_request_3;
		zoom_request_2 = zoom_request_temp_3;
		zoom_request_3 = zoom_request_temp_2;
	}
	if (zoom_request_2 != null) {
		zoom_max = zoom_request_2;
	}
	if (zoom_request_3 != null) {
		zoom_min = zoom_request_3;
	}
	if ( (zoom_request != null) && (zoom_request >= 0) ) {
		map_zoom = zoom_request;
	}
	getUrlArg(); // URL引数の再読込による表示設定情報の上書き
	if (zoom_max != null) {
		if (map_zoom > zoom_max) {
			map_zoom = zoom_max;
		}
	}
	if (zoom_min != null) {
		if (map_zoom < zoom_min) {
			map_zoom = zoom_min;
		}
	}
	map.setCenter(new google.maps.LatLng(center_lat, center_lng));
	map.setZoom(map_zoom);
	map.setMapTypeId(map_type_id);
	if (mapTypeControlStyle == "") {
		mapTypeControlStyle = google.maps.MapTypeControlStyle.DEFAULT;
	}
	if ( !(mapTypeIdsArray.length > 0) ) {
		mapTypeIdsArray = [];
		for (var i = 0; i < map_type_options_preset.length; i++) {
			if (mapTypeIdFromNameWord(map_type_options_preset[i]) != null) {
				mapTypeIdsArray.push(mapTypeIdFromNameWord(map_type_options_preset[i]));
			}
		}
	}
	map.setOptions({
		maxZoom: zoom_max,
		minZoom: zoom_min,
		mapTypeControlOptions: {
			mapTypeIds: mapTypeIdsArray,
			style: mapTypeControlStyle
		}
	});
	for (var i = 0 ; i < markers.length; i++) {
		if ( (layerVisibility[i] == true) && (markers[i].getLength() > 0) ) {
			markers[i].forEach(function(marker, index){
				marker.setVisible(true);
			});
		}
		if ( (layerVisibility[i] == true) && (groundoverlays[i].getLength() > 0) ) {
			groundoverlays[i].forEach(function(groundoverlay, index){
				groundoverlay.setOpacity(groundoverlays_opacity[i][index]);
				groundoverlay.setOptions({clickable: groundoverlays_clickable[i][index]});
			});
		}
	}
	if (markers.length > 1) {
		layerName[0] = "レイヤ 0";
	} else {
		layerName[0] = "上載せ情報";
	}
	setVisibilityControl();
	if (opening_message != "") {
		if ( (opening_message_lat == "") || (opening_message_lng == "") ) {
			opening_message_lat = center_lat;
			opening_message_lng = center_lng;
		}
		infowindow.setContent(opening_message);
		infowindow.setPosition(new google.maps.LatLng(opening_message_lat, opening_message_lng));
		infowindow.open(map);
	}
	if ( layout_type == 2 ) {  // ▼▼▼ Goma-Aw ▼▼▼
		if (textPageRightHtml != "") {
			description = textPageRightHtml;
		}
		description_reset();
	}  // ▲▲▲ Goma-Aw ▲▲▲
	// ▼▼▼ 検索機能の組込 ▼▼▼
	if (use_search_box == true) {
		if ( document.getElementById("search_box") ) {
			if ( document.getElementById("place") == null ) {
				document.getElementById("search_box").innerHTML = ( '<form action=\"#\" method=\"post\" onsubmit=\"searchPlace(this.place.value); return false;\">'
					+ '<input type=\"text\" id=\"place\" name=\"place\" size=\"60\" maxlength=\"2048\" value=\"\" title=\"地図を検索\"> '
					+ '<input type=\"submit\" value=\"検索\">'
					+ '</form>' );
			}
			geocoder = new google.maps.Geocoder();
			infowindow_search = new google.maps.InfoWindow({
				content: "",
				maxWidth: info_window_max_width
			});
			google.maps.event.addListener(infowindow_search, 'closeclick', function() {
				document.getElementById("place").value = "";
				document.getElementById("place").blur();
			});
			google.maps.event.addListener(map, 'click', function() {
				infowindow_search.close();
				document.getElementById("place").value = "";
				document.getElementById("place").blur();
			});
			// document.getElementById("place").value = "";
		}
	} else {
		if (document.getElementById("search_box")) {
			document.getElementById("search_box").innerHTML = "";
		}
	}
	// ▲▲▲ 検索機能の組込 ▲▲▲
	// ▼▼▼ このページへのリンクの組込 ▼▼▼
	if ( (use_link_url == true) && (document.getElementById("link_div")) ) {
		document.getElementById("link_div").innerHTML = "<div>このページのURL</div>";
		document.getElementById("link_div").innerHTML += "<div style=\"margin-left:2em; word-break:break-all;\"><span id=\"link_url\">( Not Available )</span></div>";
		document.getElementById("link_div").innerHTML += "<div style=\"margin:0.2em 0em 1em 2em;\"><input type=\"button\" name=\"ButtonWriteUrl\" id=\"ButtonWriteUrl\" onClick=\"writeUrl();\" value=\"現在の地図表示状態に更新\" style=\"font-size:80%\" title=\"現在の地図表示状態を再現するURLに更新します。\" /></div>";
		document.getElementById("link_div").innerHTML += "<hr />";
	}
	writeInitialUrl();
	// ▲▲▲ このページへのリンクの組込 ▲▲▲
	// ▼▼▼ 地図以外のページ内容の記述 ▼▼▼
	if ( document.getElementById("text_top") ) {
		document.getElementById("text_top").innerHTML = textPageTopHtml;
	}
	if ( document.getElementById("text_bottom") ) {
		document.getElementById("text_bottom").innerHTML = textPageBottomHtml;
	}
	if ( textPageHeadTitle != "" ) {
		document.title = textPageHeadTitle;
	}
	// 地図出典注釈表示
	if ( document.getElementById("map_source") ) {
		var mapSourceNoteHtml = mapSourceNote(map_type_id, mapTypeIdsArray);
		if (mapSourceNoteHtml != "") {
			document.getElementById("map_source").innerHTML = '<div style=\"margin-bottom:1em\">［地図について］</div>' + mapSourceNoteHtml;
		} else {
			document.getElementById("map_source").innerHTML = '';
		}
	}
	// ▲▲▲ 地図以外のページ内容の記述 ▲▲▲
	if ( layout_type == 4 ) {  // ▼▼▼ Goma-Awタイプ４ ▼▼▼
		// 地図以外のページ内容の記述
		if (textPageFullHtml != "") {
			description = textPageFullHtml;
		} else if ( (textPageTopHtml != "") || (textPageBottomHtml != "") ) {
			description = textPageTopHtml + textPageRightHtml + textPageBottomHtml;
		}
		description += '<hr style=\"margin-top:1em;\" />';
		// 検索機能の組込
		if (use_search_box == true) {
			description += '<div style=\"margin-top:1em; margin-bottom:1em;\">';
			description += ( '<form action=\"#\" method=\"post\" onsubmit=\"searchPlace(this.place.value); return false;\">'
					+ '<input type=\"text\" id=\"place\" name=\"place\" size=\"18\" maxlength=\"2048\" value=\"\" title=\"地図を検索\"> '
					+ '<input type=\"submit\" value=\"検索\">'
					+ '</form>' );
			description += '</div>';
			description += '<hr />';
			geocoder = new google.maps.Geocoder();
			infowindow_search = new google.maps.InfoWindow({
				content: "",
				maxWidth: info_window_max_width
			});
			google.maps.event.addListener(infowindow_search, 'closeclick', function() {
				document.getElementById("place").value = "";
				document.getElementById("place").blur();
			});
			google.maps.event.addListener(map, 'click', function() {
				infowindow_search.close();
				document.getElementById("place").value = "";
				document.getElementById("place").blur();
			});
			// document.getElementById("place").value = "";
		}
		// このページへのリンクの組込
		if (use_link_url == true) {
			description += '<div style=\"margin:1em 0em;\">';
			description += '<div>このページのURL</div>';
			description += '<div style=\"margin-left:0.5em; word-break:break-all;\"><span id=\"link_url\">( Not Available )</span></div>';
			description += '<div style=\"margin:0.2em 0em 0em 0.2em;\"><input type=\"button\" name=\"ButtonWriteUrl\" id=\"ButtonWriteUrl\" onClick=\"writeUrl();\" value=\"現在の地図表示状態に更新\" style=\"font-size:80%\" title=\"現在の地図表示状態を再現するURLに更新します。\" /></div>';
			description += '</div>';
			description += '<hr />';
		}
		// システム情報記載ページへのリンク，記述完了
		description += '<div style=\"font-size:100%;\"><a href=\"#\" onclick=\"description_systemInfo(); return false;\">［地図について］</a></div>';
		description_reset();
		// システム情報（地図出典，バージョン情報）
		description4system += '<div style=\"text-align:right; font-size:100%;\"><a href=\"#\" onclick=\"description_reset(); return false;\">［戻る］</a></div>';
		description4system += '<h4 style=\"margin:0.2em 0em;\">この地図について</h4>';
		description4system += '<div style=\"margin:0.5em 0em; font-size:70%; line-height:120%; text-align:justify; text-justify:inter-ideograph;\">' + mapSourceNote(map_type_id, mapTypeIdsArray) + '</div>';
		description4system += description4system0;
		description4system += '<hr />';
		description4system += '<div style=\"font-size:100%;\"><a href=\"#\" onclick=\"description_reset(); return false;\">［戻る］</a></div>';
		if ( document.getElementById("description_s") ) {
			document.getElementById("description_s").innerHTML = description4system;
		}
		// サイドバーの表示設定
		setSideBarControl();
		if (sideBarVisibility == true) {
			showSideBar(1);
		} else {
			showSideBar(0);
		}
	}  // ▲▲▲ Goma-Awタイプ４ ▲▲▲
	setColorbox(); // jQuery Colorbox のセット
}

function createInfoHtml(item_html, item_link_url, item_link_target, item_title, item_text, item_image_url, item_image_width, item_image_height) {
	var html_a1 = ""; var html_a2 = ""; var html_h = ""; var html_img = ""; var html_p = "";
	var image_width_description = ""; var image_height_description = "";
	var created_html = "";
	item_title = item_title.replace(/</g, "&lt;"); item_title = item_title.replace(/>/g, "&gt;");
	item_text = item_text.replace(/</g, "&lt;"); item_text = item_text.replace(/>/g, "&gt;");
	item_title = item_title.replace(/\\n/g, "<br />");
	item_text = item_text.replace(/\\n/g, "<br />");
	if ( !(item_link_url.match(/^\s*$/)) ) {
		if ( !(item_link_url.match(/^\w+\:/)) && !(item_link_url.match(/^\/+/)) ) {
			item_link_url = data_dir + item_link_url;
		}
		switch ( item_link_target.toLowerCase() ) {
			case "":
				html_a1 = "<a href=\"" + item_link_url + "\" target=\"_self\">";
				break;
			case "_lightbox":
			case "_colorbox":
				html_a1 = "<a href=\"" + item_link_url + "\" class=\"lightbox\" target=\"" + item_link_target + "\">";
				break;
			default:
				html_a1 = "<a href=\"" + item_link_url + "\" target=\"" + item_link_target + "\">";
				break;
		}
		html_a2 = "</a>";
		if ( (item_title.match(/^\s*$/)) && (item_image_url.match(/^\s*$/)) && (item_text.match(/^\s*$/)) ) {
			html_p = "<p style=\"margin:0.5em 0em;\">" + html_a1 + item_link_url + html_a2 + "</p>";
		}
	}
	if ( !(item_image_url.match(/^\s*$/)) ) {
		if ( !(item_image_url.match(/^\w+\:/)) && !(item_image_url.match(/^\/+/)) ) {
			item_image_url = data_dir + item_image_url;
		}
		if ( (item_image_width != "") && !(isNaN(item_image_width - 0)) && (Math.round(item_image_width) > 0) ) {
			image_width_description = " width=\"" + parseInt(item_image_width, 10) + "\"";
		}
		if ( (item_image_height != "") && !(isNaN(item_image_height - 0)) && (Math.round(item_image_height) > 0) ) {
			image_height_description = " height=\"" + parseInt(item_image_height, 10) + "\"";
		}
		html_img = "<div style=\"margin:0.5em 0em;\">" + html_a1 + "<img src=\"" + item_image_url + "\""
			+ image_width_description + image_height_description + " border=\"0\" alt=\"[ Picture ]\" />" + html_a2 + "</div>";
		html_a1 = ""; html_a2 = "";
	}
	if ( !(item_title.match(/^\s*$/)) ) {
		html_h = "<h4 style=\"margin:0.5em 0em;\">" + html_a1 + item_title + html_a2 + "</h4>";
	}
	if ( !(item_text.match(/^\s*$/)) ) {
		html_p = "<p style=\"margin:0.5em 0em; text-align:justify; text-justify:inter-ideograph;\">" + html_a1 + item_text + html_a2 + "</p>";
	}
	created_html = html_h + html_img + html_p + item_html;
	return created_html;
}

function createInfoHtmlForPage(item_html, item_link_url, item_link_target, item_title, item_text, item_image_url, item_image_width, item_image_height) {
	var html_a1 = ""; var html_a2 = ""; var html_h = ""; var html_img = ""; var html_p = "";
	var image_width_description = ""; var image_height_description = "";
	var created_html = "";
	item_title = item_title.replace(/</g, "&lt;"); item_title = item_title.replace(/>/g, "&gt;");
	item_text = item_text.replace(/</g, "&lt;"); item_text = item_text.replace(/>/g, "&gt;");
	item_title = item_title.replace(/\\n/g, "<br />");
	item_text = item_text.replace(/\\n/g, "<br />");
	if ( !(item_link_url.match(/^\s*$/)) ) {
		if ( !(item_link_url.match(/^\w+\:/)) && !(item_link_url.match(/^\/+/)) ) {
			item_link_url = data_dir + item_link_url;
		}
		switch ( item_link_target.toLowerCase() ) {
			case "":
				html_a1 = "<a href=\"" + item_link_url + "\" target=\"_self\">";
				break;
			case "_lightbox":
			case "_colorbox":
				html_a1 = "<a href=\"" + item_link_url + "\" class=\"lightbox\" target=\"" + item_link_target + "\">";
				break;
			default:
				html_a1 = "<a href=\"" + item_link_url + "\" target=\"" + item_link_target + "\">";
				break;
		}
		html_a2 = "</a>";
		if ( (item_title.match(/^\s*$/)) && (item_image_url.match(/^\s*$/)) && (item_text.match(/^\s*$/)) ) {
			html_p = "<p style=\"margin:0.5em 0em;\">" + html_a1 + item_link_url + html_a2 + "</p>";
		}
	}
	if ( !(item_image_url.match(/^\s*$/)) ) {
		if ( !(item_image_url.match(/^\w+\:/)) && !(item_image_url.match(/^\/+/)) ) {
			item_image_url = data_dir + item_image_url;
		}
		if ( (item_image_width != "") && !(isNaN(item_image_width - 0)) && (Math.round(item_image_width) > 0) ) {
			image_width_description = " width=\"" + parseInt(item_image_width, 10) + "\"";
		}
		if ( (item_image_height != "") && !(isNaN(item_image_height - 0)) && (Math.round(item_image_height) > 0) ) {
			image_height_description = " height=\"" + parseInt(item_image_height, 10) + "\"";
		}
		html_img = "<div style=\"margin:0.5em 0em;\">" + html_a1 + "<img src=\"" + item_image_url + "\""
			+ image_width_description + image_height_description + " border=\"0\" alt=\"[ Picture ]\" />" + html_a2 + "</div>";
		html_a1 = ""; html_a2 = "";
	}
	if ( !(item_title.match(/^\s*$/)) ) {
		html_h = "<h2 style=\"margin:0.5em 0em;\">" + html_a1 + item_title + html_a2 + "</h2>";
	}
	if ( !(item_text.match(/^\s*$/)) ) {
		html_p = "<p style=\"margin:0.5em 0em; text-align:justify; text-justify:inter-ideograph;\">" + html_a1 + item_text + html_a2 + "</p>";
	}
	created_html = html_h + html_img + html_p + item_html;
	return created_html;
}

function addMarker(mkr_type, mkr_lat, mkr_lng, mkr_attr, mkr_titl, mkr_html, mkr_layer) {
	var marker = null;
	switch (mkr_type) {
		case "marker":
			marker = new google.maps.Marker({
					position: new google.maps.LatLng(mkr_lat, mkr_lng),
					title: mkr_titl,
					visible: false,
					map: map
			});
			// mkr_attr は（今のところ）使用しない。
			setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html);
			markers[mkr_layer].push(marker);
			break;
		case "circle":
			if ( (mkr_lat != "") && (mkr_lng != "") ) {
				if ( (mkr_attr == "") || mkr_attr.match(/^\s*$/) ) { mkr_attr = "#ff3f00"; }
				marker = new google.maps.Circle({
						center: mkr_lat,
						radius: mkr_lng,
						strokeColor: mkr_attr,
						strokeOpacity: 0.8,
						strokeWeight: 3,
						fillColor: mkr_attr,
						fillOpacity: 0.2,
						visible: false,
						map: map
				});
				setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html);
				markers[mkr_layer].push(marker);
			}
			break;
		case "polyline":
			if ( (mkr_attr == "") || mkr_attr.match(/^\s*$/) ) { mkr_attr = "#ff3f00"; }
			marker = new google.maps.Polyline({
					path: mkr_lat,
					strokeColor: mkr_attr,
					strokeOpacity: 0.8,
					strokeWeight: 3,
					geodesic: true,
					visible: false,
					map: map
			});
			setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html);
			markers[mkr_layer].push(marker);
			break;
		case "polygon":
			if ( (mkr_attr == "") || mkr_attr.match(/^\s*$/) ) { mkr_attr = "#ff3f00"; }
			marker = new google.maps.Polygon({
					path: mkr_lat,
					strokeColor: mkr_attr,
					strokeOpacity: 0.8,
					strokeWeight: 3,
					fillColor: mkr_attr,
					fillOpacity: 0.2,
					geodesic: true,
					visible: false,
					map: map
			});
			setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html);
			markers[mkr_layer].push(marker);
			break;
		case "rectangle":
			if ( (mkr_lat != "") && (mkr_lng != "") ) {
				if ( (mkr_attr == "") || mkr_attr.match(/^\s*$/) ) { mkr_attr = "#ff3f00"; }
				marker = new google.maps.Rectangle({
						bounds: correctBounds(mkr_lat, mkr_lng),
						strokeColor: mkr_attr,
						strokeOpacity: 0.8,
						strokeWeight: 2,
						fillColor: mkr_attr,
						fillOpacity: 0.2,
						visible: false,
						map: map
				});
				setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html);
				markers[mkr_layer].push(marker);
			}
			break;
		case "groundoverlay":
			if ( (mkr_lat != "") && (mkr_lng != "") ) {
				var fileUrl = "";
				if ( mkr_titl.match(/^\w+\:\/\/\S+$/) ) { // 完全なURLの場合
					fileUrl = mkr_titl;
				} else if ( mkr_titl.match(/^[\/]/) ) { // 絶対パスの場合
					fileUrl = mkr_titl;
				} else { // 相対パス(orファイル名のみ)の場合
					fileUrl = data_dir + mkr_titl;
				}
				marker = new google.maps.GroundOverlay(fileUrl, correctBounds(mkr_lat, mkr_lng));
				marker.setOpacity(0);
				marker.setOptions({clickable: false});
				marker.setMap(map);
				var opacity = 1;
				if ((mkr_attr != "") && !(isNaN(mkr_attr-0))) {
					if ((mkr_attr >= 0) && (mkr_attr <= 1)) {
						opacity = mkr_attr - 0;
					} else if ((mkr_attr > 1) && (mkr_attr <= 100)) {
						opacity = mkr_attr / 100;
					} else {
						opacity = 1;
					}
				} else {
					opacity = 1;
				}
				var clickable = false;
				if (mkr_html != "") {
					clickable = true;
				}
				setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html);
				groundoverlays[mkr_layer].push(marker);
				groundoverlays_opacity[mkr_layer].push(opacity);
				groundoverlays_clickable[mkr_layer].push(clickable);
			}
			break;
		case "message":
			if ( (mkr_lat != "") && !(isNaN(mkr_lat - 0))
					&& (mkr_lng != "") && !(isNaN(mkr_lng - 0)) ) {
				opening_message_lat = mkr_lat;
				opening_message_lng = mkr_lng;
			}
			opening_message += mkr_html;
			break;
	}
	return marker;
}

function setMarkerPopup(marker, mkr_type, mkr_titl, mkr_html) {
	var mkr_popup_msg = "";
	if (mkr_html != "") {
		switch (mkr_type) {
			case "marker":
				if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
					if (mkr_titl != "") {
						mkr_popup_msg = "<h3 style=\"margin:0.5em 0em; font-size:90%;\">"+ mkr_titl + "</h3><hr />";
					}
					mkr_popup_msg += "<p style=\"margin:0.5em 0em;\">この地点に関する情報を<br />表示しています。</p>";
					google.maps.event.addListener(marker, 'click', function() {
						infowindow.close();
						description_set(mkr_html);
						infowindow.setContent(mkr_popup_msg);
						infowindow.setOptions({pixelOffset: new google.maps.Size(0,0)});
						infowindow.open(map, marker);
						setColorbox(); // jQuery Colorbox のセット
					});
				} else {  // ▲▲▲ Goma-Aw ▲▲▲ // ▼▼▼ 通常 ▼▼▼
					google.maps.event.addListener(marker, 'click', function() {
						infowindow.close();
						infowindow.setContent(mkr_html);
						infowindow.setOptions({pixelOffset: new google.maps.Size(0,0)});
						infowindow.open(map, marker);
						setColorbox(); // jQuery Colorbox のセット
					});
				}  // ▲▲▲ 通常 ▲▲▲
				break;
			case "circle":
			case "polyline":
			case "polygon":
			case "rectangle":
			case "groundoverlay":
				if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
					if (mkr_type == "groundoverlay") { // mkr_titlをファイル名指定に使用しているのでタイトルは無効
						mkr_popup_msg = "<p style=\"margin:0.5em 0em;\">この地図に関する情報を<br />表示しています。</p>";
					} else {
						if (mkr_titl != "") {
							mkr_popup_msg = "<h3 style=\"margin:0.5em 0em; font-size:90%;\">"+ mkr_titl + "</h3><hr />";
						}
						mkr_popup_msg += "<p style=\"margin:0.5em 0em;\">ここに関する情報を<br />表示しています。</p>";
					}
					google.maps.event.addListener(marker, 'click', function(event) {
						infowindow.close();
						description_set(mkr_html);
						infowindow.setContent(mkr_popup_msg);
						infowindow.setPosition(event.latLng);
						infowindow.setOptions({pixelOffset: new google.maps.Size(0,0)});
						infowindow.open(map);
						setColorbox(); // jQuery Colorbox のセット
					});
				} else {  // ▲▲▲ Goma-Aw ▲▲▲ // ▼▼▼ 通常 ▼▼▼
					google.maps.event.addListener(marker, 'click', function(event) {
						infowindow.close();
						infowindow.setContent(mkr_html);
						infowindow.setPosition(event.latLng);
						infowindow.setOptions({pixelOffset: new google.maps.Size(0,0)});
						infowindow.open(map);
						setColorbox(); // jQuery Colorbox のセット
					});
				}  // ▲▲▲ 通常 ▲▲▲
				break;
		}
	} else {
		switch (mkr_type) {
			case "marker":
				if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
					if (mkr_titl != "") {
						mkr_popup_msg = "<h3 style=\"margin:0.5em 0em; font-size:90%;\">"+ mkr_titl + "</h3><hr />";
					}
					mkr_popup_msg += "<p style=\"margin:0.5em 0em;\">この地点についての表示<br />する内容はありません。</p>";
					google.maps.event.addListener(marker, 'click', function() {
						infowindow.close();
						description_reset();
						infowindow.setContent(mkr_popup_msg);
						infowindow.setOptions({pixelOffset: new google.maps.Size(0,0)});
						infowindow.open(map, marker);
					});
				} else {  // ▲▲▲ Goma-Aw ▲▲▲ // ▼▼▼ 通常 ▼▼▼
					if (mkr_titl != "") {
						mkr_popup_msg = "<h3 style=\"margin:0.5em 0em; font-size:90%;\">"+ mkr_titl + "</h3><hr />";
					}
					mkr_popup_msg += "<p style=\"margin:0.5em 0em;\">この地点についての表示<br />する内容はありません。</p>";
					google.maps.event.addListener(marker, 'click', function() {
						infowindow.close();
						infowindow.setContent(mkr_popup_msg);
						infowindow.setOptions({pixelOffset: new google.maps.Size(0,0)});
						infowindow.open(map, marker);
					});
				}  // ▲▲▲ 通常 ▲▲▲
				break;
			case "circle":
			case "polyline":
			case "polygon":
			case "rectangle":
				marker.setOptions({clickable: false});
				break;
			case "groundoverlay":
				// 呼び出し元で clickable = false の設定
				break;
		}
	}
}

// ▼▼▼ Goma-Aw の場合のみ使用する関数 ▼▼▼
function description_set(html) {
	document.getElementById("description").innerHTML = "<div>" + html + "</div>";
	if ( document.getElementById("description_s") ) {
		document.getElementById("description").style.display = "block";
		document.getElementById("description_s").style.display = "none";
	}
	document.getElementById("description_canvas").scrollTop = 0;
	if ( layout_type == 4 ) {
		showSideBar(1);
	}
	return html;
}

function description_reset() {
	document.getElementById("description").innerHTML = description;
	if ( (layout_type == 4) && (use_link_url == true) ) {
		writeInitialUrl();
	}
	if ( document.getElementById("description_s") ) {
		document.getElementById("description").style.display = "block";
		document.getElementById("description_s").style.display = "none";
	}
	document.getElementById("description_canvas").scrollTop = 0;
	setColorbox(); // jQuery Colorbox のセット
	return description;
}

function description_systemInfo() {
	if ( document.getElementById("description_s") ) {
		document.getElementById("description").style.display = "none";
		document.getElementById("description_s").style.display = "block";
	} else {
		document.getElementById("description").innerHTML = description4system;
	}
	document.getElementById("description_canvas").scrollTop = 0;
	return description4system;
}
// ▲▲▲ Goma-Aw の場合のみ使用する関数 ▲▲▲

// ▼▼▼ サイドバー表示/非表示切り替えで使用する関数 ▼▼▼
function setSideBarControl() {
	var customControlDiv_SideBar = document.createElement('DIV');
	customControlDiv_SideBar.style.padding = '10px';
	var customControlBox_SideBar = document.createElement('DIV');
	var sideBarControlHtml = "";
	sideBarControlHtml += '<a href=\"#\" onclick=\"showSideBar(); return false;\">';
	sideBarControlHtml += '<div style=\"background-color:#ffffff; padding:6px; border-radius:2px; box-shadow:0px 1px 3px 0px rgba(0,0,0,0.22);\">';
	if (sideBarVisibility == true) {
		sideBarControlHtml += '<img id=\"sidebar_control1\" class=\"iconSideBarRight\" src=\"' + iconSideBar_right_close + '\" title=\"説明画面を閉じる\" style=\"vertical-align:middle;\">';
		sideBarControlHtml += '<img id=\"sidebar_control2\" class=\"iconSideBarBottom\" src=\"' + iconSideBar_bottom_close + '\" title=\"説明画面を閉じる\" style=\"vertical-align:middle;\">';
	} else {
		sideBarControlHtml += '<img id=\"sidebar_control1\" class=\"iconSideBarRight\" src=\"' + iconSideBar_right_open + '\" title=\"説明画面を開く\" style=\"vertical-align:middle;\">';
		sideBarControlHtml += '<img id=\"sidebar_control2\" class=\"iconSideBarBottom\" src=\"' + iconSideBar_bottom_open + '\" title=\"説明画面を開く\" style=\"vertical-align:middle;\">';
	}
	sideBarControlHtml += '</div>';
	sideBarControlHtml += '</a>';
	customControlBox_SideBar.innerHTML = sideBarControlHtml;
	customControlDiv_SideBar.appendChild(customControlBox_SideBar);
	map.controls[google.maps.ControlPosition.RIGHT_BOTTOM].push(customControlDiv_SideBar);
}

function showSideBar(argVisibility) {
	var orderToShow = true;
	if (sideBarVisibility == true) {
		orderToShow = false;
	} else {
		orderToShow = true;
	}
	if (argVisibility == 0) {
		orderToShow = false;
	} else if (argVisibility == 1) {
		orderToShow = true;
	}
	if (orderToShow == true) {
		if ( document.getElementById("description_canvas") ) {
			document.getElementById("map_canvas").className = 'canvasMap_sideOpen';
			document.getElementById("description_canvas").className = 'canvasDes_sideOpen';
		}
		if ( document.getElementById("sidebar_control1") ) {
			document.getElementById("sidebar_control1").src = iconSideBar_right_close;
			document.getElementById("sidebar_control1").title = '説明画面を閉じる';
		}
		if ( document.getElementById("sidebar_control2") ) {
			document.getElementById("sidebar_control2").src = iconSideBar_bottom_close;
			document.getElementById("sidebar_control2").title = '説明画面を閉じる';
		}
		sideBarVisibility = true;
	} else {
		infowindow.close();
		description_reset();
		if ( document.getElementById("description_canvas") ) {
			document.getElementById("map_canvas").className = 'canvasMap_sideClosed';
			document.getElementById("description_canvas").className = 'canvasDes_sideClosed';
		}
		if ( document.getElementById("sidebar_control1") ) {
			document.getElementById("sidebar_control1").src = iconSideBar_right_open;
			document.getElementById("sidebar_control1").title = '説明画面を開く';
		}
		if ( document.getElementById("sidebar_control2") ) {
			document.getElementById("sidebar_control2").src = iconSideBar_bottom_open;
			document.getElementById("sidebar_control2").title = '説明画面を開く';
		}
		sideBarVisibility = false;
	}
	google.maps.event.trigger(map, 'resize');
}
// ▲▲▲ サイドバー表示/非表示切り替えで使用する関数 ▲▲▲

function correctBounds(latlng1, latlng2) {
	var lat1 = 0; var lng1 = 0; var lat2 = 0; var lng2 = 0;
	var new_bounds = null;
	if ( latlng1.lat() <= latlng2.lat() ) {
		lat1 = latlng1.lat();
		lat2 = latlng2.lat();
	} else {
		lat1 = latlng2.lat();
		lat2 = latlng1.lat();
	}
	if ( (latlng2.lng() - latlng1.lng() >= 0) && (latlng2.lng() - latlng1.lng() <= 180) ) {
		lng1 = latlng1.lng();
		lng2 = latlng2.lng();
	} else if ( latlng2.lng() - latlng1.lng() > 180 ) {
		lng1 = latlng2.lng();
		lng2 = latlng1.lng();
	} else if ( (latlng2.lng() - latlng1.lng() >= -180) && (latlng2.lng() - latlng1.lng() < 0) ) {
		lng1 = latlng2.lng();
		lng2 = latlng1.lng();
	} else if ( latlng2.lng() - latlng1.lng() < -180 ) {
		lng1 = latlng1.lng();
		lng2 = latlng2.lng();
	}
	new_bounds = new google.maps.LatLngBounds (new google.maps.LatLng(lat1, lng1), new google.maps.LatLng(lat2, lng2));
	return new_bounds;
}

function accessGpx(gpxFile, layerIndex, useCacheString) {
	var gpxUrl = "";
	var useCache = false; 
	if (gpxFile.match(/^\S+$/)) {
		if ( gpxFile.match(/\.$/) ) {  // ファイル名末尾がピリオド
			gpxFile += "gpx";
		}
		if ( !(gpxFile.split('/')[gpxFile.split('/').length - 1].match(/\./)) ) {  // ファイル名に拡張子なし
			gpxFile += ".gpx";
		}
		if ( !(gpxFile.match(/\.gpx$/i)) ) {  // ファイル名末尾が .gpx 以外
		//	gpxFile += ".gpx";
		}
		if (gpxFile.match(/^\w+\:/) || gpxFile.match(/^[\/]/)) {  // 絶対パスの場合
			gpxUrl = gpxFile;
		} else {  // 相対パスの場合
			gpxUrl = data_dir + gpxFile;
		}
		if ( (useCacheString.toLowerCase() == "yes") || (useCacheString.toLowerCase() == "cache") ) {
			useCache = true; 
		}
		downloadText(gpxUrl, evaluateGpx, true, layerIndex, useCache);
	}
}

function evaluateGpx(gpxData, layerIndex) {
	var lat = ""; var lng = ""; var path = ""; var attr = ""; var titl = ""; var html = ""; var titl_html = ""; var desc = "";
	var obj_type = ""; var data_hold = false;
	if ( (gpxData != undefined) && (gpxData != null) ) {
		if (gpxData.getElementsByTagName('gpx').length > 0) {
			var wpts_length = gpxData.getElementsByTagName('wpt').length;
			for (var i = 0 ; i < wpts_length; i++) {
				var wpt = gpxData.getElementsByTagName('wpt').item(i);
				lat = ""; lng = ""; attr = ""; titl = ""; html = ""; titl_html = ""; desc = "";
				obj_type = "marker";
				lat = wpt.getAttribute("lat");
				lng = wpt.getAttribute("lon");
				var wptNames = wpt.getElementsByTagName('name');
				if ( (wptNames.length > 0) && (wptNames.item(0).childNodes[0] != null) ) {
					titl = wptNames.item(0).childNodes[0].nodeValue;
					titl_html = '<h4 style=\"margin:0.5em 0em;\">' + titl + '</h4>';
				}
				var wptDescs = wpt.getElementsByTagName('desc');
				if ( (wptDescs.length > 0) && (wptDescs.item(0).childNodes[0] != null) ) {
					desc = '<div>' + wptDescs.item(0).childNodes[0].nodeValue + '</div>';
				}
				html = titl_html + desc;
				if ( (lat != null) && (lat != "") && !(isNaN(lat - 0))
						&& (lng != null) && (lng != "") && !(isNaN(lng - 0)) ) {
					addMarker(obj_type, lat, lng, attr, titl, html, layerIndex);
				}
			}
			var rtes_length = gpxData.getElementsByTagName('rte').length;
			for (var i = 0 ; i < rtes_length; i++) {
				lat = ""; lng = ""; titl = ""; html = ""; titl_html = ""; desc = "";
				path = [];
				var rtepts_length = gpxData.getElementsByTagName('rte').item(i).getElementsByTagName('rtept').length;
				for (var j = 0 ; j < rtepts_length ; j++) {
					var rtept = gpxData.getElementsByTagName('rte').item(i).getElementsByTagName('rtept').item(j);
					lat = ""; lng = ""; attr = ""; titl = ""; html = ""; titl_html = ""; desc = "";
					obj_type = "marker";
					lat = rtept.getAttribute("lat");
					lng = rtept.getAttribute("lon");
					var rteptNames = rtept.getElementsByTagName('name');
					if ( (rteptNames.length > 0) && (rteptNames.item(0).childNodes[0] != null) ) {
						titl = rteptNames.item(0).childNodes[0].nodeValue;
						titl_html = '<h4 style=\"margin:0.5em 0em;\">' + titl + '</h4>';
					}
					var rteptDescs = rtept.getElementsByTagName('desc');
					if ( (rteptDescs.length > 0) && (rteptDescs.item(0).childNodes[0] != null) ) {
						desc = '<div>' + rteptDescs.item(0).childNodes[0].nodeValue + '</div>';
					}
					html = titl_html + desc;
					if ( (lat != null) && (lat != "") && !(isNaN(lat - 0))
							&& (lng != null) && (lng != "") && !(isNaN(lng - 0)) ) {
						addMarker(obj_type, lat, lng, attr, titl, html, layerIndex);
						path.push(new google.maps.LatLng(lat, lng));
					}
				}
				lat = ""; lng = ""; titl = ""; html = ""; titl_html = ""; desc = "";
				obj_type = "polyline";
				attr = "#ff3f00";
				var rteNames = gpxData.getElementsByTagName('rte').item(i).getElementsByTagName('name');
				if ( (rteNames.length > 0) && (rteNames.item(0).childNodes[0] != null) ) {
					titl = rteNames.item(0).childNodes[0].nodeValue;
					titl_html = '<h4 style=\"margin:0.5em 0em;\">' + titl + '</h4>';
				}
				var rteDescs = gpxData.getElementsByTagName('rte').item(i).getElementsByTagName('desc');
				if ( (rteDescs.length > 0) && (rteDescs.item(0).childNodes[0] != null) ) {
					desc = '<div>' + rteDescs.item(0).childNodes[0].nodeValue + '</div>';
				}
				html = titl_html + desc;
				if ( path.length > 1 ) {
					addMarker(obj_type, path, lng, attr, titl, html, layerIndex);
				}
			}
			var trks_length = gpxData.getElementsByTagName('trk').length;
			for (var i = 0 ; i < trks_length; i++) {
				lat = ""; lng = ""; titl = ""; html = ""; titl_html = ""; desc = "";
				var trkNames = gpxData.getElementsByTagName('trk').item(i).getElementsByTagName('name');
				if ( (trkNames.length > 0) && (trkNames.item(0).childNodes[0] != null) ) {
					titl = trkNames.item(0).childNodes[0].nodeValue;
					titl_html = '<h4 style=\"margin:0.5em 0em;\">' + titl + '</h4>';
				}
				var trkDescs = gpxData.getElementsByTagName('trk').item(i).getElementsByTagName('desc');
				if ( (trkDescs.length > 0) && (trkDescs.item(0).childNodes[0] != null) ) {
					desc = '<div>' + trkDescs.item(0).childNodes[0].nodeValue + '</div>';
				}
				html = titl_html + desc;
				var trksegs = gpxData.getElementsByTagName('trk').item(i).getElementsByTagName('trkseg');
				var trksegs_length = gpxData.getElementsByTagName('trk').item(i).getElementsByTagName('trkseg').length;
				for (var j = 0 ; j < trksegs_length ; j++) {
					path = [];
					var trkpts_length = gpxData.getElementsByTagName('trk').item(i).getElementsByTagName('trkseg').item(j).getElementsByTagName('trkpt').length;
					for (var k = 0 ; k < trkpts_length; k++) {
						var trkpt = gpxData.getElementsByTagName('trk').item(i).getElementsByTagName('trkseg').item(j).getElementsByTagName('trkpt').item(k);
						lat = trkpt.getAttribute("lat");
						lng = trkpt.getAttribute("lon");
						if ( (lat != null) && (lat != "") && !(isNaN(lat - 0))
								&& (lng != null) && (lng != "") && !(isNaN(lng - 0)) ) {
							path.push(new google.maps.LatLng(lat, lng));
						}
					}
					lat = ""; lng = "";
					obj_type = "polyline";
					attr = "#ff7f00";
					if ( path.length > 1 ) {
						addMarker(obj_type, path, lng, attr, titl, html, layerIndex);
					}
				}
			}
			for (var i = 0 ; i < markers.length; i++) {
				if ( (layerVisibility[i] == true) && (markers[i].getLength() > 0) ) {
					markers[i].forEach(function(marker, index){
						marker.setVisible(true);
					});
				}
			}
		} else {
			alert ("GPXファイルではありません。\n（gpx要素がないか，XMLの解析でエラーが発生しました。）");
		}
	} else {
			alert ("GPXファイルではありません。\n（XMLの解析ができませんでした。）");
	}
}

function renderKml(kmlFile, layerName, visibilityString) {
	var kmlUrl = ""; var kmlLayer = null;
	if (kmlFile.match(/^\S+$/)) {
		if ( kmlFile.match(/\.$/) ) {  // ファイル名末尾がピリオド
			kmlFile += "kml";
		}
		if ( !(kmlFile.split('/')[kmlFile.split('/').length - 1].match(/\./)) ) {  // ファイル名に拡張子なし
			kmlFile += ".kml";
		}
		if ( !(data_file.match(/\.kml$/i)) && !(data_file.match(/\.kmz$/i)) ) {  // ファイル名末尾が .kml または .kmz 以外
		//	data_file += ".kml";
		}
		if ( kmlFile.match(/^\w+\:/) ) { // 完全なURLの場合→そのまま採用
			kmlUrl = kmlFile;
		} else if ( kmlFile.match(/^[\/]/) ) { // 絶対パスの場合→URLのホスト名までを付加
			if (default_url != "") {
				var hostName = default_url.match(/^(\w+\:\/\/.*?[^\/])[\/]/)[1];
				kmlUrl = hostName + kmlFile;
			}
		} else { // 相対パスの場合→さらに分岐処理が必要
			if (data_dir == "") { // <data>パス指定なしの場合→URLを付加
				if (default_url != "") {
					kmlUrl = default_url + kmlFile;
				}
			} else if ( data_dir.match(/^\w+\:/) ) { // 完全なURLの場合→<data>を付加
				if (default_url != "") {
					kmlUrl = data_dir + kmlFile;
				}
			} else if ( data_dir.match(/^[\/]/) ) { // 絶対パスの場合→URLのホスト名まで+<data>を付加
				if (default_url != "") {
					var hostName = default_url.match(/^(\w+\:\/\/.*?[^\/])[\/]/)[1];
					kmlUrl = hostName + data_dir + kmlFile;
				}
			} else { // 相対パスの場合→URL+<data>を付加
				if (default_url != "") {
					kmlUrl = default_url + data_dir + kmlFile;
				}
			}
		}
	}
	if (kmlUrl != "") {
		var kmlLayerIndex = kmlLayerNum;
		kmlLayerNum += 1;
		if (layerName.match(/^\s*$/)) {
			kmlLayerName[kmlLayerIndex] = "";
		} else {
			kmlLayerName[kmlLayerIndex] = layerName;
		}
		if (visibility_marker == false) {
			kmlLayerVisibility[kmlLayerIndex] = false;
		} else if (visibilityString.toLowerCase() == "yes") {
			kmlLayerVisibility[kmlLayerIndex] = true;
		} else if (visibilityString.toLowerCase() == "no") {
			kmlLayerVisibility[kmlLayerIndex] = false;
		} else {
			kmlLayerVisibility[kmlLayerIndex] = true;
		}
		var kmlLayerOptions = {
				url: kmlUrl,
				preserveViewport: true,
				suppressInfoWindows: true
			};
		kmlLayers[kmlLayerIndex] = new google.maps.KmlLayer(kmlLayerOptions);
		if (kmlLayerVisibility[kmlLayerIndex] == true) {
			kmlLayers[kmlLayerIndex].setMap(map);
		}
		if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
			var mkr_popup_msg = "<p style=\"margin:0.5em 0em;\">ここに関する情報を<br />表示しています。</p>";
			google.maps.event.addListener(kmlLayers[kmlLayerIndex], 'click', function(kmlMouseEvent) {
				infowindow.close();
				description_set(kmlMouseEvent.featureData.infoWindowHtml);
				infowindow.setContent(mkr_popup_msg);
				infowindow.setPosition(kmlMouseEvent.latLng);
				infowindow.setOptions({pixelOffset: kmlMouseEvent.pixelOffset});
				infowindow.open(map);
			});
		} else {  // ▲▲▲ Goma-Aw ▲▲▲ // ▼▼▼ 通常 ▼▼▼
			google.maps.event.addListener(kmlLayers[kmlLayerIndex], 'click', function(kmlMouseEvent) {
				infowindow.close();
				infowindow.setContent(kmlMouseEvent.featureData.infoWindowHtml);
				infowindow.setPosition(kmlMouseEvent.latLng);
				infowindow.setOptions({pixelOffset: kmlMouseEvent.pixelOffset});
				infowindow.open(map);
			});
		}  // ▲▲▲ 通常 ▲▲▲
	}
	return kmlLayers[kmlLayerIndex];
}

function accessJson(jsonFile, layerName, visibilityString, useCacheString) {
	var jsonUrl = "";
	var useCache = false; 
	if (jsonFile.match(/^\S+$/)) {
		var jsonLayerIndex = jsonLayerNum;
		jsonLayerNum += 1;
		if (layerName.match(/^\s*$/)) {
			jsonLayerName[jsonLayerIndex] = "";
		} else {
			jsonLayerName[jsonLayerIndex] = layerName;
		}
		if (visibility_marker == false) {
			jsonLayerVisibility[jsonLayerIndex] = false;
		} else if (visibilityString.toLowerCase() == "yes") {
			jsonLayerVisibility[jsonLayerIndex] = true;
		} else if (visibilityString.toLowerCase() == "no") {
			jsonLayerVisibility[jsonLayerIndex] = false;
		} else {
			jsonLayerVisibility[jsonLayerIndex] = true;
		}
		if ( jsonFile.match(/\.$/) ) {  // ファイル名末尾がピリオド
			jsonFile += "geojson";
		}
		if ( !(jsonFile.split('/')[jsonFile.split('/').length - 1].match(/\./)) ) {  // ファイル名に拡張子なし
			jsonFile += ".geojson";
		}
		if ( !(data_file.match(/\.geojson$/i)) && !(data_file.match(/\.json$/i)) ) {  // ファイル名末尾が .geojson または .json 以外
		//	data_file += ".geojson";
		}
		if (jsonFile.match(/^\w+\:/) || jsonFile.match(/^[\/]/)) {  // 絶対パスの場合
			jsonUrl = jsonFile;
		} else {  // 相対パスの場合
			jsonUrl = data_dir + jsonFile;
		}
		if ( (useCacheString.toLowerCase() == "yes") || (useCacheString.toLowerCase() == "cache") ) {
			useCache = true; 
		}
		downloadText(jsonUrl, evaluateJson, false, jsonLayerIndex, useCache);
	}
}

function evaluateJson(jsonString, jsonLayerIndex) {
	var jsonData = null;
	if ( (jsonString != undefined) && (jsonString != null) ) {
		jsonData = eval( "(" + jsonString + ")" );
		if (jsonLayerIndex < 0) {
			jsonLayerIndex = 0;
		}
		jsonLayers[jsonLayerIndex] = map.data.addGeoJson(jsonData);
		// jsonLayers[jsonLayerIndex] は，１つのGeoJSONファイル内のフィーチャーの配列
		map.data.setStyle({
			strokeWeight: 3,
			strokeColor: '#ff3f00',
			strokeOpacity: 0.8,
			fillColor: '#ff7f00',
			fillOpacity: 0.2
		});
		for (var i = 0 ; i < jsonLayers[jsonLayerIndex].length; i++) {
			if (jsonLayerVisibility[jsonLayerIndex] == true) {
				map.data.overrideStyle(jsonLayers[jsonLayerIndex][i], {visible: true});
			} else {
				map.data.overrideStyle(jsonLayers[jsonLayerIndex][i], {visible: false});
			}
		}
		map.data.addListener('click', function(event) {
			var mkr_html = "<h4 style=\"margin:0.5em 0em;\">このフィーチャの属性情報</h4>";
			var propertiesHtml = "";
			event.feature.forEachProperty(function(propertyValue, propertyName) {
				var propertyNameAndValue = propertyName + " : " + propertyValue;
				// JSONファイルの内容にJavaScriptが含まれる場合はエスケープする。
				if (propertyNameAndValue.search(/<script/i) != -1) {
					propertyNameAndValue = "JSON file contains script! Escaped content below.<br />" + propertyNameAndValue.replace(/</g, "&lt;");
				}
				propertiesHtml += ("<div>" + propertyNameAndValue + "</div>");
			});
			if (propertiesHtml != "") {
				mkr_html += ("<div>" + propertiesHtml + "</div>");
			} else {
				mkr_html = "このフィーチャに属性情報はありません。";
			}
			var targetPosition = event.latLng;
			var targetPositionOffset = new google.maps.Size(0,0);
			var featureType = event.feature.getGeometry().getType();
			if (featureType == "Point") {
				targetPosition = event.feature.getGeometry().get();
				targetPositionOffset = new google.maps.Size(0,-40);
			}
			if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
				var mkr_popup_msg = "<p style=\"margin:0.5em 0em;\">ここに関する情報を<br />表示しています。</p>";
				infowindow.close();
				description_set(mkr_html);
				infowindow.setContent(mkr_popup_msg);
				infowindow.setPosition(targetPosition);
				infowindow.setOptions({pixelOffset: targetPositionOffset});
				infowindow.open(map);
			} else {  // ▲▲▲ Goma-Aw ▲▲▲ // ▼▼▼ 通常 ▼▼▼
				infowindow.close();
				infowindow.setContent(mkr_html);
				infowindow.setPosition(targetPosition);
				infowindow.setOptions({pixelOffset: targetPositionOffset});
				infowindow.open(map);
			}  // ▲▲▲ 通常 ▲▲▲
		});
	} else {
			alert ("GeoJSONファイルを取得できませんでした。");
	}
}

function setVisibilityControl() {
	var strChecked = '';
	if ( (markers.length > 1) || (markers[0].getLength() > 0) || (groundoverlays[0].getLength() > 0) || (kmlLayerNum > 0) || (jsonLayerNum > 0) ) {
		var customControlDiv_Visibility = document.createElement('DIV');
		customControlDiv_Visibility.style.padding = '0px 10px 5px';
		var customControlBox_Visibility = document.createElement('DIV');
		customControlBox_Visibility.style.backgroundColor = '#ffffff';
		customControlBox_Visibility.style.boxShadow = '0px 1px 3px 0px rgba(0,0,0,0.22)';
		customControlBox_Visibility.style.padding = '3px';
		customControlBox_Visibility.style.cursor = 'pointer';
		for (var i = 0 ; i < kmlLayerNum; i++) {
			if (kmlLayerVisibility[i] == true) {
				strChecked = ' checked';
			} else {
				strChecked = '';
			}
			if (kmlLayerName[i] == "") {
				if (kmlLayerNum == 1) {
					kmlLayerName[i] = 'KML レイヤ';
				} else {
					kmlLayerName[i] = 'KML ' + (i + 1);
				}
			}
			var customControl_VisibilityOfKml = document.createElement('DIV');
			customControl_VisibilityOfKml.innerHTML = '<label style=\"white-space:nowrap; cursor:pointer;\"><input type=\"checkbox\" name="ChkboxOnKmlVisibility' + i + '" id="ChkboxOnKmlVisibility' + i + '" onClick=\"changeVisibilityOfKml(' + i + ');\"' + strChecked + ' style=\"\" />' + kmlLayerName[i] + '</label>';
			customControl_VisibilityOfKml.title = 'レイヤの表示を切り替え';
			customControl_VisibilityOfKml.style.fontSize = '13px';
			customControl_VisibilityOfKml.style.margin = '2px';
			customControlBox_Visibility.appendChild(customControl_VisibilityOfKml);
		}
		for (var i = 0 ; i < jsonLayerNum; i++) {
			if (jsonLayerVisibility[i] == true) {
				strChecked = ' checked';
			} else {
				strChecked = '';
			}
			if (jsonLayerName[i] == "") {
				if (jsonLayerNum == 1) {
					jsonLayerName[i] = 'GeoJSON レイヤ';
				} else {
					jsonLayerName[i] = 'GeoJSON ' + (i + 1);
				}
			}
			var customControl_VisibilityOfJson = document.createElement('DIV');
			customControl_VisibilityOfJson.innerHTML = '<label style=\"white-space:nowrap; cursor:pointer;\"><input type=\"checkbox\" name="ChkboxOnJsonVisibility' + i + '" id="ChkboxOnJsonVisibility' + i + '" onClick=\"changeVisibilityOfJson(' + i + ');\"' + strChecked + ' style=\"\" />' + jsonLayerName[i] + '</label>';
			customControl_VisibilityOfJson.title = 'レイヤの表示を切り替え';
			customControl_VisibilityOfJson.style.fontSize = '13px';
			customControl_VisibilityOfJson.style.margin = '2px';
			customControlBox_Visibility.appendChild(customControl_VisibilityOfJson);
		}
		for (var i = 0 ; i < markers.length; i++) {
			if ( (markers[i].getLength() > 0) || (groundoverlays[i].getLength() > 0) || (layerIncludeGpx[i]) == true ) {
				if (layerVisibility[i] == true) {
					strChecked = ' checked';
				} else {
					strChecked = '';
				}
				var customControl_VisibilityOfMarker = document.createElement('DIV');
				customControl_VisibilityOfMarker.innerHTML = '<label style=\"white-space:nowrap; cursor:pointer;\"><input type=\"checkbox\" name="ChkboxOnMarkerVisibility' + i + '" id="ChkboxOnMarkerVisibility' + i + '" onClick=\"changeVisibilityOfMarker(' + i + ');\"' + strChecked + ' style=\"\" />' + layerName[i] + '</label>';
				customControl_VisibilityOfMarker.title = 'レイヤの表示を切り替え';
				customControl_VisibilityOfMarker.style.fontSize = '13px';
				customControl_VisibilityOfMarker.style.margin = '2px';
				customControlBox_Visibility.appendChild(customControl_VisibilityOfMarker);
			}
		}
		customControlDiv_Visibility.appendChild(customControlBox_Visibility);
		map.controls[google.maps.ControlPosition.LEFT_TOP].push(customControlDiv_Visibility);
	}
}

function changeVisibilityOfMarker(layerIndex) {
	var chkboxOnMarkerVisibility = document.getElementById("ChkboxOnMarkerVisibility" + layerIndex);
	if (chkboxOnMarkerVisibility.checked) {
		markers[layerIndex].forEach(function(marker, index){
			marker.setVisible(true);
		});
		groundoverlays[layerIndex].forEach(function(groundoverlay, index){
			groundoverlay.setOpacity(groundoverlays_opacity[layerIndex][index]);
			groundoverlay.setOptions({clickable: groundoverlays_clickable[layerIndex][index]});
		});
		layerVisibility[layerIndex] = true;
	} else {
		infowindow.close();
		if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
			description_reset();
		}  // ▲▲▲ Goma-Aw ▲▲▲
		markers[layerIndex].forEach(function(marker, index){
			marker.setVisible(false);
		});
		groundoverlays[layerIndex].forEach(function(groundoverlay, index){
			groundoverlay.setOpacity(0);
			groundoverlay.setOptions({clickable: false});
		});
		layerVisibility[layerIndex] = false;
	}
}

function changeVisibilityOfKml(kmlLayerIndex) {
	var chkboxOnKmlVisibility = document.getElementById("ChkboxOnKmlVisibility" + kmlLayerIndex);
	if (chkboxOnKmlVisibility.checked) {
		kmlLayers[kmlLayerIndex].setMap(map);
		kmlLayerVisibility[kmlLayerIndex] = true;
	} else {
		infowindow.close();
		if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
			description_reset();
		}  // ▲▲▲ Goma-Aw ▲▲▲
		kmlLayers[kmlLayerIndex].setMap(null);
		kmlLayerVisibility[kmlLayerIndex] = false;
	}
}

function changeVisibilityOfJson(jsonLayerIndex) {
	var chkboxOnJsonVisibility = document.getElementById("ChkboxOnJsonVisibility" + jsonLayerIndex);
	if (chkboxOnJsonVisibility.checked) {
		for (var i = 0 ; i < jsonLayers[jsonLayerIndex].length; i++) {
			map.data.overrideStyle(jsonLayers[jsonLayerIndex][i], {visible: true});
		}
		jsonLayerVisibility[jsonLayerIndex] = true;
	} else {
		infowindow.close();
		if ( (layout_type == 2) || (layout_type == 4) ) {  // ▼▼▼ Goma-Aw ▼▼▼
			description_reset();
		}  // ▲▲▲ Goma-Aw ▲▲▲
		for (var i = 0 ; i < jsonLayers[jsonLayerIndex].length; i++) {
			map.data.overrideStyle(jsonLayers[jsonLayerIndex][i], {visible: false});
		}
		jsonLayerVisibility[jsonLayerIndex] = false;
	}
}

// ▼▼▼ 検索機能組込の場合のみ使用する関数 ▼▼▼
function searchPlace(place_query) {
	if (geocoder) {
		infowindow_search.close();
		if ( !(place_query.match(/^\s*$/)) ) {
			geocoder.geocode( {'address': place_query}, function(results, status) {
				if (status == google.maps.GeocoderStatus.OK) {
					geocode_results = results;
					geocode_index = 0;
					showResult(0);
				} else if (status == google.maps.GeocoderStatus.ZERO_RESULTS) {
					alert(place_query + " という場所は見つかりませんでした。");
					// document.getElementById("place").value = "";
				} else {
					alert("検索できませんでした。\nStatus: " + status);
				}
			});
		} else {
			document.getElementById("place").value = "";
		}
	}
}

function showResult(request) {
	if (request == 1) {
		geocode_index += 1;
		if (geocode_index > geocode_results.length - 1) {
			geocode_index = geocode_results.length - 1;
		}
	} else if (request == -1) {
		geocode_index -= 1;
		if (geocode_index < 0) {
			geocode_index = 0;
		}
	} else if (request == 0) {
		// geocode_index = 0;
	}
	map.fitBounds(geocode_results[geocode_index].geometry.viewport);
	map.setCenter(geocode_results[geocode_index].geometry.location);
	var infowindow_html = "<div>" + geocode_results[geocode_index].formatted_address + "</div>";
	if ( (geocode_index > 0) || (geocode_index < geocode_results.length - 1) ) {
		infowindow_html += "<div style=\"margin-top:1em; font-size:80%; line-height:150%;\">";
		if (geocode_index > 0) {
			infowindow_html += "<span style=\"color:blue;\" onclick=\"showResult(-1);\">≪ 前の検索結果</span>";
		}
		if ( (geocode_index > 0) && (geocode_index < geocode_results.length - 1) ) {
			infowindow_html += "<span style=\"color:gray;\"> || </span>";
		}
		if (geocode_index < geocode_results.length - 1) {
			infowindow_html += "<span style=\"color:blue;\" onclick=\"showResult(1);\">次の検索結果 ≫</span>";
		}
		infowindow_html += "</div>";
	}
	infowindow_search.setPosition(geocode_results[geocode_index].geometry.location);
	infowindow_search.setContent(infowindow_html);
	infowindow_search.open(map);
}
// ▲▲▲ 検索機能組込の場合のみ使用する関数 ▲▲▲

function jump(lat, lng, z) {
	var new_lat = 0; var new_lng = 0; var new_zoom = 0;
	if ( (lat != null) && (lat > -85) && (lat < 85) ) {
		new_lat = lat;
	} else {
		new_lat = map.getCenter().lat();
	}
	if ( (lng != null) && (lng >= -180) && (lng <= 180) ) {
		new_lng = lng;
	} else {
		new_lng = map.getCenter().lng();
	}
	map.setCenter(new google.maps.LatLng(new_lat, new_lng));
	if ( (z != null) && (z > 0) && (z < 22) ) {
		if (z > zoom_max) {z = zoom_max;}
		if (z < zoom_min) {z = zoom_min;}
		new_zoom = z;
		map.setZoom(new_zoom);
	}
}

function changeMap(requestedMapName) {
	var requestedMapTypeId = mapTypeIdFromNameWord(requestedMapName);
	if (requestedMapTypeId != null) {
		map.setMapTypeId(requestedMapTypeId);
	} else {
		alert("Invalid Map Type !");
	}
}

function writeInitialUrl() {
	var url = location.protocol + "//" + location.host + location.pathname + location.search;
	var link_description = "<a href=\"" + url + "\">" + url + "</a>";
	if ( document.getElementById("link_url") ) {
		document.getElementById("link_url").innerHTML = link_description;
	}
}

function writeUrl() {
	var lat_center = Math.round(map.getCenter().lat() * 1000000) / 1000000;
	var lng_center = Math.round(map.getCenter().lng() * 1000000) / 1000000;
	if (lng_center > 180) {
		lng_center = (lng_center + 180) % 360 -180;
	} else if (lng_center < -180) {
		lng_center = -1 * ( (-1 * lng_center + 180) % 360 -180);
	}
	var zoom = map.getZoom();
	var map_type_code = "";
	switch ( map.getMapTypeId() ) {
		case google.maps.MapTypeId.ROADMAP:
			map_type_code = "m";
			break;
		case google.maps.MapTypeId.TERRAIN:
			map_type_code = "p";
			break;
		case google.maps.MapTypeId.SATELLITE:
			map_type_code = "k";
			break;
		case google.maps.MapTypeId.HYBRID:
			map_type_code = "h";
			break;
		case "GSIstd":
			map_type_code = "gsistd";
			break;
		case "GSIpale":
			map_type_code = "gsipale";
			break;
		case "GSIenglish":
			map_type_code = "english";
			break;
		case "GSIrelief":
			map_type_code = "relief";
			break;
		case "GSIlcm25k":
			map_type_code = "gsilcm";
			break;
		case "GSIlum4bl":
			map_type_code = "gsilum";
			break;
		case "GSIphoto":
			map_type_code = "gsiphoto";
			break;
		case "GSIort":
		case "GSIort2":
			map_type_code = "gsiort";
			break;
		case "GSIair":
			map_type_code = "gsiair";
			break;
		case "GSIgazo1":
			map_type_code = "gsigazo1";
			break;
		case "GSIgazo2":
			map_type_code = "gsigazo2";
			break;
		case "GSIgazo3":
			map_type_code = "gsigazo3";
			break;
		case "GSIgazo4":
			map_type_code = "gsigazo4";
			break;
		case "GSIortOld10":
			map_type_code = "gsiortold10";
			break;
		case "GSIortUSA10":
			map_type_code = "gsiortusa10";
			break;
		case "Kiban25000":
			map_type_code = "kiban25000";
			break;
		case "Kiban2500":
			map_type_code = "kiban2500";
			break;
		case "Kiban25000a":
			map_type_code = "kiban25000a";
			break;
		case "Kiban25000c":
			map_type_code = "kiban25000c";
			break;
		case "FindsHawmsKanto":
			map_type_code = "findshawmskanto";
			break;
		case "Kjmap2man":
			map_type_code = "kjmap2man";
			break;
		case "Kjmap25k1920":
			map_type_code = "kjmap25k1920";
			break;
		case "Kjmap25k1930":
			map_type_code = "kjmap25k1930";
			break;
		case "Kjmap25k1950":
			map_type_code = "kjmap25k1950";
			break;
		case "Kjmap25k1970":
			map_type_code = "kjmap25k1970";
			break;
		case "Kjmap50k1910":
			map_type_code = "kjmap50k1910";
			break;
		case "Kjmap50k1940":
			map_type_code = "kjmap50k1940";
			break;
		case "GSItoho1":
			map_type_code = "gsitoho1";
			break;
		case "GSItoho2":
			map_type_code = "gsitoho2";
			break;
		case "Coordinate":
			map_type_code = "coord";
			break;
		case "CoordinateSw":
			map_type_code = "coordsw";
			break;
		case "White":
			map_type_code = "white";
			break;
		default:
			if (use_ext_tile == true) {
				map_type_code = extMapTypeCodeForUrl( map.getMapTypeId() );
			}
			break;
	}
	var visibility_marker_code = "";
	if (visibility_marker == false) {
		visibility_marker_code = "n";
	}
	var use_search_box_code = "";
	if (use_search_box == true) {
		use_search_box_code = "y";
	} else {
		use_search_box_code = "n";
	}
	var use_link_url_code = "y";
	var url = location.protocol + "//" + location.host + location.pathname;
	url += "?ll=" + lat_center + "," + lng_center;
	url += "&z=" + zoom;
	if (url_arg_data != "") {
		url += "&data=" + url_arg_data;
	}
	if (url_arg_file != "") {
		url += "&file=" + url_arg_file;
	}
	if (map_type_code != "") {
		url += "&t=" + map_type_code;
	}
	if (visibility_marker_code != "") {
		url += "&vm=" + visibility_marker_code;
	}
//	url += "&search=" + use_search_box_code;
//	url += "&url=" + use_link_url_code;
	var link_description = "<a href=\"" + url + "\">" + url + "</a>";
	if ( document.getElementById("link_url") ) {
		document.getElementById("link_url").innerHTML = link_description;
	}
}

function getUrlArg() {
	var url_arg = [];
	url_arg["ll"] = ""; url_arg["z"] = ""; url_arg["t"] = "";
	url_arg["data"] = ""; url_arg["file"] = ""; url_arg["cache"] = "";
	url_arg["vm"] = ""; url_arg["vo"] = "";
	url_arg["search"] = ""; url_arg["url"] = ""; url_arg["side"] = "";
	var url_arg_str = location.search.substr(1).split('&');
	for (var i = 0; i < url_arg_str.length; i++) {
		var s = url_arg_str[i].split('=');
		url_arg[s[0]] = decodeURIComponent(s[1]);
	}
	var ll = url_arg["ll"].split(',');
	if ( (ll[0] != "") && !(isNaN(ll[0] - 0)) && (ll[1] != "") && !(isNaN(ll[1] - 0)) ) {
		if ( (ll[0] >= -90) && (ll[0] <= 90) && (ll[1] >= -180) && (ll[1] <= 180) ) {
			center_lat = ll[0];
			center_lng = ll[1];
		}
	}
	if ( (url_arg["z"] != "") && !(isNaN(url_arg["z"] - 0)) ) {
		if ( (url_arg["z"] >= 0) && (url_arg["z"] <= 21) ) {
			map_zoom = parseInt(url_arg["z"], 10);
		}
	}
	if (url_arg["t"] != "") {
		if (mapTypeIdFromNameWord(url_arg["t"]) != null) {
			map_type_id = mapTypeIdFromNameWord(url_arg["t"]);
		}
	}
	if (url_arg["data"] != "") {
		if (url_arg["data"].match(/^[\w\-\.\/]+$/)) {
			url_arg_data = url_arg["data"];
			data_dir = url_arg_data;
			if ( !(data_dir.match(/\/$/)) ) {
				data_dir += "/";
			}
		}
	}
	if (url_arg["file"] != "") {
		if (url_arg["file"].match(/^[\w\-][\w\-\.]*$/)) {
			url_arg_file = url_arg["file"];
			data_file = url_arg_file;
			if ( data_file.match(/\.$/) ) {  // ファイル名末尾がピリオド
				data_file += "txt";
			}
			if ( !(data_file.match(/\./)) ) {  // ファイル名に拡張子なし
				data_file += ".txt";
			}
			if ( !(data_file.match(/\.txt$/i)) ) {  // ファイル名末尾が .txt 以外
			//	data_file += ".txt";
			}
		}
	}
	switch ( url_arg["cache"] ) {
		case "refresh":
		case "reload":
		case "no":
		case "n":
			cache_refresh = true;
			break;
	}
	switch ( url_arg["vm"] ) {
		case "yes":
		case "y":
			visibility_marker = true;
			break;
		case "no":
		case "n":
			visibility_marker = false;
			break;
	}
	switch ( url_arg["search"] ) {
		case "yes":
		case "y":
			use_search_box = true;
			break;
		case "no":
		case "n":
			use_search_box = false;
			break;
	}
	switch ( url_arg["url"] ) {
		case "yes":
		case "y":
			use_link_url = true;
			break;
		case "no":
		case "n":
			use_link_url = false;
			break;
	}
	switch ( url_arg["side"] ) {
		case "yes":
		case "y":
			sideBarVisibility = true;
			break;
		case "no":
		case "n":
			sideBarVisibility = false;
			break;
	}
}

function downloadText(url, funcAfterDownload, forXml, forwardingArg, useCache) {
	var httpObj = null; var httpObjType = null;
	try {
		httpObj = new XMLHttpRequest();
		httpObjType = "XMLHttpRequest";
	} catch (e) {
		try {
			httpObj = new ActiveXObject("Msxml2.XMLHTTP");
			httpObjType = "Msxml2.XMLHTTP";
		} catch (e) {
			try {
				httpObj = new ActiveXObject("Microsoft.XMLHTTP");
				httpObjType = "Microsoft.XMLHTTP";
			} catch (e) {
				httpObj = null; httpObjType = null;
			}
		}
	}
	if (httpObj) {
		httpObj.onreadystatechange = function() {
			if (httpObj.readyState == 4) {
				var loadedContents = null; var httpStatusCode = null; var httpStatusText = null;
				try {
					if (httpObj.status == 200) {
						if (forXml == true) {
							loadedContents = httpObj.responseXML;
						} else {
							loadedContents = httpObj.responseText;
						}
					}
					httpStatusCode = httpObj.status;
					httpStatusText = httpObj.statusText;
				} catch (e) {
					httpStatusCode = 0;
				}
				if (httpStatusCode == 200) {
					funcAfterDownload(loadedContents, forwardingArg);
				} else {
					alert("Failed in downloading data.\n\n" + "http status: " + httpStatusCode + " " + httpStatusText + "\n\nURL: " + url);
				}
			}
		};
		httpObj.open('GET', url, true);
		if ( !(useCache == true) || (cache_refresh == true) ) {
			httpObj.setRequestHeader('Pragma', 'no-cache');
			httpObj.setRequestHeader('Cache-Control', 'no-cache');
			httpObj.setRequestHeader('If-Modified-Since', 'Thu, 01 Jun 1970 00:00:00 GMT');
		}
		httpObj.send(null);
	} else {
		alert("Failed in downloading a data file.\n\n" + "Cannot send the HTTP request.");
	}
	return httpObjType;
}

window.onload = load;
window.onresize = function () { google.maps.event.trigger(map, 'resize'); }
